Attribute VB_Name = "USB_DutWriter"
Public CHECK_BYTE As Byte
Public DATA_BYTE(40) As Byte
Public DeviceInfoSet As Long
Public MyDeviceInterfaceData As SP_DEVICE_INTERFACE_DATA
Public DetailDataBuffer() As Byte
Public Security As SECURITY_ATTRIBUTES
Public DeviceAttributes As HIDD_ATTRIBUTES
Public MyDeviceInfoData As SP_DEVINFO_DATA
Public MyDeviceInterfaceDetailData As SP_DEVICE_INTERFACE_DETAIL_DATA
Public Capabilities As HIDP_CAPS
Public bAlertable As Long
'Public Capabilities As HIDP_CAPS
Public DataString As String
Public DetailData As Long
'Public DetailDataBuffer() As Byte
'Public DeviceAttributes As HIDD_ATTRIBUTES
Public DevicePathName As String
'Public DeviceInfoSet As Long
Public ErrorString As String
Public EventObject As Long
Public HIDHandle As Long
Public HIDOverlapped As OVERLAPPED
Public LastDevice As Boolean
Public MyDeviceDetected As Boolean
'Public MyDeviceInfoData As SP_DEVINFO_DATA
'Public MyDeviceInterfaceDetailData As SP_DEVICE_INTERFACE_DETAIL_DATA
'Public MyDeviceInterfaceData As SP_DEVICE_INTERFACE_DATA
Public Needed As Long
Public PreparsedData As Long
Public ReadHandle As Long
Public result As Long
'Public Security As SECURITY_ATTRIBUTES
Public timeout As Boolean
Public Const MyVendorID = &H451 '&H925
Public MyProductID
'Public Const MyProductID = &H1234 '&H1234
'Public ReadPosition(40) As String
Public DataFromUSB(40), ReadData(40), ACK_Responce(40) As Byte
Public ReportResults As String
Public DebugOn
Public NumberOfReads, NumberOfACKS
Public Word(40) As String
Public ErrorMsg As String
Public old_row, old_col
Public USB_Read_Error As Boolean

Public inter_ads1P As Double
Public slope_ads1P As Double
Public inter_ads1M As Double
Public slope_ads1M As Double
Public inter_ads2P As Double
Public slope_ads2P As Double
Public inter_ads2M As Double
Public slope_ads2M As Double
Public inter_dac_A As Double
Public slope_dac_A As Double
Public inter_dac_B As Double
Public slope_dac_B As Double
Public inter_dac_C As Double
Public slope_dac_C As Double
Public inter_dac_D As Double
Public slope_dac_D As Double

Public inter_ads1P3 As Double
Public slope_ads1P3 As Double
Public inter_ads1M3 As Double
Public slope_ads1M3 As Double
Public inter_ads2P3 As Double
Public slope_ads2P3 As Double
Public inter_ads2M3 As Double
Public slope_ads2M3 As Double
Public inter_dac_A3 As Double
Public slope_dac_A3 As Double
Public inter_dac_B3 As Double
Public slope_dac_B3 As Double
Public inter_dac_C3 As Double
Public slope_dac_C3 As Double
Public inter_dac_D3 As Double
Public slope_dac_D3 As Double

Public Slope_I_loop As Double
Public inter_I_loop As Double

Public m_ads1(10) As Double
Public b_ads1(10) As Double
Public m_dac_B(10) As Double
Public b_dac_B(10) As Double

Public Vref As Double
Public Mux_Setting As Double

Public Save_IN_N1
Public Save_IN_P1
Public Save_IN_N2
Public Save_IN_P2

Public ads_Conf As Integer
Public dac_autocal As Integer
Public USB_Disconnected As Boolean

Public LastMonthChecked As Double
Public LastYearChecked As Double
Public LegacyAddress As Boolean




Public Function DisplayEngineering(ByVal Inval As Double) As String
'from pga309
    Dim Suffix As String
    Dim Sign As Integer
    Sign = Sgn(Inval)
    Inval = Abs(Inval)
    If Inval > 1000000000000# Then
        Suffix = "T"
        Inval = Inval / 1000000000000#
    ElseIf Inval > 1000000000# Then
        Suffix = "G"
        Inval = Inval / 1000000000#
    ElseIf Inval > 1000000# Then
        Suffix = "M"
        Inval = Inval / 1000000#
    ElseIf Inval > 1000# Then
            Suffix = "K"
        Inval = Inval / 1000#
    ElseIf Inval > 1 Then
        Suffix = " "
    ElseIf Inval > 0.001 Then
        Suffix = "m"
        Inval = Inval / 0.001
    ElseIf Inval > 0.000001 Then
        Suffix = "u"
        Inval = Inval / 0.000001
    ElseIf Inval > 0.000000001 Then
        Suffix = "n"
        Inval = Inval / 0.000000001
    ElseIf Inval > 0.000000000001 Then
        Suffix = "p"
        Inval = Inval / 0.000000000001
    ElseIf Inval > 0.000000000000001 Then
        Suffix = "f"
        Inval = Inval / 0.000000000000001
    End If
    DisplayEngineering = EuroFormat(Sign * Inval, "##0.000") & Suffix
End Function
Public Function DisplayScientific(ByVal Inval As Double, ByVal NumFrmt As String) As String
Dim X, Y, mant, xxx, yyy

If Inval <> 0 Then
X = Log(Abs(Inval)) / Log(10)
If X < 0 Then
Y = -Int(Abs(X) + 1)
Else
Y = Int(X)
End If
mant = Inval / (10 ^ Y)
    If Y > 0 Then
    yyy = Format(mant, NumFrmt)
    xxx = Int(Abs(Val(yyy)))
        If xxx >= 10 Then
            mant = mant / 10
            Y = Y + 1
        End If
        DisplayScientific = Format(mant, NumFrmt) + "E+" + Right(Str(Y), Len(Str(Y)) - 1)
    Else
        DisplayScientific = Format(mant, NumFrmt) + "E" + Str(Y)
    End If
End If
End Function
Public Function Read_ADS1100_1(OutputFormat As Integer) As Variant
'OutputFormat -- 0=voltage out, 1=counts out
Dim i, ADS_Code

If OutputFormat = 1 Then
    Vref = 5
ElseIf OutputFormat = 2 Then
    Vref = 3
End If

Call RunMnemonicCommand("I2C CH2 S 91 ACKS R ACKM R ACKM P")
ADS_Code = ReadData(0) * 256 + ReadData(1)
If (ReadData(0) And 128) <> 0 Then
    ADS_Code = (Not ADS_Code) And 65535
    ADS_Code = -((ADS_Code) + 1)
End If

If OutputFormat <> 4 Then ' Voltage out
    Read_ADS1100_1 = ADS_Code * Vref / 32768 '+ Offset
ElseIf OutputFormat = 4 Then ' counts out
    Read_ADS1100_1 = ADS_Code
End If

If OutputFormat = 1 Then
    If Read_ADS1100_1 > 0 Then
        Read_ADS1100_1 = Read_ADS1100_1 * slope_ads1P + inter_ads1P
    Else
        Read_ADS1100_1 = Read_ADS1100_1 * slope_ads1M + inter_ads1M
    End If
ElseIf OutputFormat = 2 Then
    If Read_ADS1100_1 > 0 Then
        Read_ADS1100_1 = Read_ADS1100_1 * slope_ads1P3 + inter_ads1P3
    Else
        Read_ADS1100_1 = Read_ADS1100_1 * slope_ads1M3 + inter_ads1M3
    End If
End If

End Function
Public Sub ADS_MUX1(IN_P, IN_N)
If IN_P = "OPEN" Then
    Mux_Setting = Mux_Setting And &HFE 'reset sw1
    Mux_Setting = Mux_Setting And &HF7 'reset sw4
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "GND" Then
    Mux_Setting = Mux_Setting And &HFE 'reset sw1
    Mux_Setting = Mux_Setting Or &H8  'set  sw4
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "DAC" Then
    Mux_Setting = Mux_Setting And &HF7 'reset sw4
    Mux_Setting = Mux_Setting Or &H1  'set  sw1
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "" Then
Else
    MsgBox "ERROR IN ADS_MUX+"
End If

If IN_N = "OPEN" Then
    Mux_Setting = Mux_Setting And &HFD 'reset sw2
    Mux_Setting = Mux_Setting And &HFB 'reset sw3
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "GND" Then
    Mux_Setting = Mux_Setting And &HFD 'reset sw2
    Mux_Setting = Mux_Setting Or &H4  'set  sw3
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "DAC" Then
    Mux_Setting = Mux_Setting And &HFB 'reset sw3
    Mux_Setting = Mux_Setting Or &H2  'set  sw2
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "" Then
Else
    MsgBox "ERROR IN ADS_MUX-"
End If
If IN_N <> "" Then Save_IN_N1 = IN_N
If IN_P <> "" Then Save_IN_P1 = IN_P

End Sub
Public Sub ADS_MUX2(IN_P, IN_N)
If IN_P = "OPEN" Then
    Mux_Setting = Mux_Setting And &HEF 'reset sw1
    Mux_Setting = Mux_Setting And &H7F 'reset sw4
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "GND" Then
    Mux_Setting = Mux_Setting And &HEF 'reset sw1
    Mux_Setting = Mux_Setting Or &H80  'set  sw4
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "DAC" Then
    Mux_Setting = Mux_Setting And &H7F 'reset sw4
    Mux_Setting = Mux_Setting Or &H10  'set  sw1
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_P = "" Then
Else
    MsgBox "ERROR IN ADS_MUX+"
End If

If IN_N = "OPEN" Then
    Mux_Setting = Mux_Setting And &HDF 'reset sw2
    Mux_Setting = Mux_Setting And &HBF 'reset sw3
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "GND" Then
    Mux_Setting = Mux_Setting And &HDF 'reset sw2
    Mux_Setting = Mux_Setting Or &H40  'set  sw3
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "DAC" Then
    Mux_Setting = Mux_Setting And &HBF 'reset sw3
    Mux_Setting = Mux_Setting Or &H20 'set  sw2
    Call RunMnemonicCommand("CMD MUX " + Hex(Mux_Setting))
ElseIf IN_N = "" Then
Else
    MsgBox "ERROR IN ADS_MUX-"
End If

If IN_N <> "" Then Save_IN_N2 = IN_N
If IN_P <> "" Then Save_IN_P2 = IN_P
End Sub

Public Function Read_ADS1100_2(OutputFormat As Integer) As Variant

Dim i, ADS_Code

If OutputFormat = 1 Then
    Vref = 5
ElseIf OutputFormat = 2 Then
    Vref = 3
End If

Call RunMnemonicCommand("I2C CH2 S 93 ACKS R ACKM R ACKM P")

ADS_Code = ReadData(0) * 256 + ReadData(1)
If (ReadData(0) And 128) <> 0 Then
    ADS_Code = (Not ADS_Code) And 65535
    ADS_Code = -((ADS_Code) + 1)
End If
If OutputFormat <> 4 Then  ' Voltage out
    Read_ADS1100_2 = ADS_Code * Vref / 32768 '+ Offset
ElseIf OutputFormat = 4 Then ' counts out
    Read_ADS1100_2 = ADS_Code
End If

If OutputFormat = 1 Then
    If Read_ADS1100_2 > 0 Then
        Read_ADS1100_2 = Read_ADS1100_2 * slope_ads2P + inter_ads2P
    Else
        Read_ADS1100_2 = Read_ADS1100_2 * slope_ads2M + inter_ads2M
    End If
ElseIf OutputFormat = 2 Then
    If Read_ADS1100_2 > 0 Then
        Read_ADS1100_2 = Read_ADS1100_2 * slope_ads2P3 + inter_ads2P3
    Else
        Read_ADS1100_2 = Read_ADS1100_2 * slope_ads2M3 + inter_ads2M3
    End If
End If



End Function
Public Function Read_I_Loop(OutputFormat As Integer)
If OutputFormat <> 1 Then
    MsgBox "You must use the 5V reference for 4mA to 20mA readback"
Else
    X1 = EngineeringVal(Read_ADS1100_2(OutputFormat))
    Read_I_Loop = X1 * Slope_I_loop + inter_I_loop
End If
End Function

Public Sub Write_DAC_A_Fast(InputVoltage, OutputFormat As Integer)

Dim i, ADS_Code

If OutputFormat = 1 Then
    InputVoltage_adj = (InputVoltage - inter_dac_A) / slope_dac_A
ElseIf OutputFormat = 2 Then
    InputVoltage_adj = (InputVoltage - inter_dac_A3) / slope_dac_A3
Else
    InputVoltage_adj = InputVoltage
End If


DAC_Code = (InputVoltage_adj) * 65535 / (Vref)
DAC_MSB = ((DAC_Code) And (65280)) / 256
DAC_LSB = (DAC_Code) And (255)
Call FillFields("I2C CH2 S 98 ACKS 10 ACKS " + Hex(DAC_MSB) + " ACKS " + Hex(DAC_LSB) + " ACKS P")
For i = 0 To 31
DATA_BYTE(i) = DATA_BYTE(i)
Next i
Call ReadAndWriteToDevice2
Call InterpretResults



End Sub
Public Sub Write_DAC_A(set_voltage, OutputFormat As Integer, AutoCal As Integer)
If OutputFormat = 1 Then
    Vref = 5
    max_voltage = 4.9
    min_voltage = 0.05
ElseIf OutputFormat = 2 Then
    Vref = 3
    max_voltage = 2.95
    min_voltage = 0.05
End If

If set_voltage > max_voltage Or set_voltage < min_voltage Then
    MsgBox "Vin > max input voltage or Vin< min input voltage "
    Exit Sub
End If

If AutoCal = 1 Then
    Call Write_DAC_A_Cal(set_voltage, OutputFormat)
Else
    Call Write_DAC_A_Fast(set_voltage, OutputFormat)
End If

End Sub
Public Sub Write_DAC_B(set_voltage, OutputFormat As Integer, AutoCal As Integer)
If OutputFormat = 1 Then
    Vref = 5
    max_voltage = 4.9
    min_voltage = 0.05
ElseIf OutputFormat = 2 Then
    Vref = 3
    max_voltage = 2.95
    min_voltage = 0.05
End If

If set_voltage > max_voltage Or set_voltage < min_voltage Then
    MsgBox "Vin > max input voltage or Vin< min input voltage "
    Exit Sub
End If

If AutoCal = 1 Then
    Call Write_DAC_B_Cal(set_voltage, OutputFormat)
Else
    Call Write_DAC_B_Fast(set_voltage, OutputFormat)
End If

End Sub
Public Sub Write_DAC_C(set_voltage, OutputFormat As Integer, AutoCal As Integer)
If OutputFormat = 1 Then
    Vref = 5
    max_voltage = 4.9
    min_voltage = 0.05
ElseIf OutputFormat = 2 Then
    Vref = 3
    max_voltage = 2.95
    min_voltage = 0.05
End If

If set_voltage > max_voltage Or set_voltage < min_voltage Then
    MsgBox "Vin > max input voltage or Vin< min input voltage "
    Exit Sub
End If

If AutoCal = 1 Then
    Call Write_DAC_C_Cal(set_voltage, OutputFormat)
Else
    Call Write_DAC_C_Fast(set_voltage, OutputFormat)
End If

End Sub
Public Sub Write_DAC_D(set_voltage, OutputFormat As Integer, AutoCal As Integer)
If OutputFormat = 1 Then
    Vref = 5
    max_voltage = 4.9
    min_voltage = 0.05
ElseIf OutputFormat = 2 Then
    Vref = 3
    max_voltage = 2.95
    min_voltage = 0.05
End If

If set_voltage > max_voltage Or set_voltage < min_voltage Then
    MsgBox "Vin > max input voltage or Vin< min input voltage "
    Exit Sub
End If
If AutoCal = 1 Then
    Call Write_DAC_D_Cal(set_voltage, OutputFormat)
Else
    Call Write_DAC_D_Fast(set_voltage, OutputFormat)
End If


End Sub
Public Sub Write_DAC_A_Cal(set_voltage, OutputFormat As Integer)
Old_Save_IN_N1 = Save_IN_N1
Old_Save_IN_P1 = Save_IN_P1

Call RunMnemonicCommand("CMD EN_ADS OFF")

Call ADS_MUX1("GND", "DAC")
Call Write_DAC_A_Fast(set_voltage, OutputFormat) 'initial setting

pause (0.3) 'wait 300ms for ads1100 to do 16 bit conversion
X1 = -Read_ADS1100_1(OutputFormat)
Error_vol = X1 - set_voltage
New_Set_Voltage = set_voltage - Error_vol
Call Write_DAC_A_Fast(New_Set_Voltage, OutputFormat) 'first adjustment setting

pause (0.3)  'wait 300ms for ads1100 to do 16 bit conversion
X2 = -Read_ADS1100_1(OutputFormat)
Error_vol = X2 - set_voltage

If Abs(Error_vol) > 0.0002 Then 'optional second adjustment
    New_Set_Voltage = New_Set_Voltage - Error_vol
    Call Write_DAC_A_Fast(New_Set_Voltage, OutputFormat)
    pause (0.3)
    X3 = -Read_ADS1100_1(OutputFormat)
    Error_vol = X3 - set_voltage
End If
If Abs(Error_vol) > 0.0002 Then 'possable circuit damage if fail?
    MsgBox "Fail dac autocal."
End If
Call ADS_MUX1(Old_Save_IN_P1, Old_Save_IN_N1)
Call RunMnemonicCommand("CMD EN_ADS ON")
End Sub
Public Sub Write_DAC_B_Cal(set_voltage, OutputFormat As Integer)
Old_Save_IN_N1 = Save_IN_N1
Old_Save_IN_P1 = Save_IN_P1

Call RunMnemonicCommand("CMD EN_ADS OFF")

Call ADS_MUX1("DAC", "GND")
Call Write_DAC_B_Fast(set_voltage, OutputFormat) 'initial setting

pause (0.3) 'wait 300ms for ads1100 to do 16 bit conversion
X1 = Read_ADS1100_1(OutputFormat)
Error_vol = X1 - set_voltage
New_Set_Voltage = set_voltage - Error_vol
Call Write_DAC_B_Fast(New_Set_Voltage, OutputFormat) 'first adjustment setting

pause (0.3)  'wait 300ms for ads1100 to do 16 bit conversion
X2 = Read_ADS1100_1(OutputFormat)
Error_vol = X2 - set_voltage

If Abs(Error_vol) > 0.0002 Then 'optional second adjustment
    New_Set_Voltage = New_Set_Voltage - Error_vol
    Call Write_DAC_B_Fast(New_Set_Voltage, OutputFormat)
    pause (0.3)
    X3 = Read_ADS1100_1(OutputFormat)
    Error_vol = X3 - set_voltage
End If
If Abs(Error_vol) > 0.0002 Then 'possable circuit damage if fail?
    MsgBox "Fail dac autocal."
End If
Call ADS_MUX1(Old_Save_IN_P1, Old_Save_IN_N1)
Call RunMnemonicCommand("CMD EN_ADS ON")

End Sub
Public Sub Write_DAC_D_Cal(set_voltage, OutputFormat As Integer)
Old_Save_IN_N2 = Save_IN_N2
Old_Save_IN_P2 = Save_IN_P2

Call RunMnemonicCommand("CMD EN_ADS OFF")

Call ADS_MUX2("DAC", "GND")
Call Write_DAC_D_Fast(set_voltage, OutputFormat) 'initial setting

pause (0.3) 'wait 300ms for ads1100 to do 16 bit conversion
X1 = Read_ADS1100_2(OutputFormat)
Error_vol = X1 - set_voltage
New_Set_Voltage = set_voltage - Error_vol
Call Write_DAC_D_Fast(New_Set_Voltage, OutputFormat) 'first adjustment setting

pause (0.3)  'wait 300ms for ads1100 to do 16 bit conversion
X2 = Read_ADS1100_2(OutputFormat)
Error_vol = X2 - set_voltage

If Abs(Error_vol) > 0.0002 Then 'optional second adjustment
    New_Set_Voltage = New_Set_Voltage - Error_vol
    Call Write_DAC_D_Fast(New_Set_Voltage, OutputFormat)
    pause (0.3)
    X3 = Read_ADS1100_2(OutputFormat)
    Error_vol = X3 - set_voltage
End If
If Abs(Error_vol) > 0.0002 Then 'possable circuit damage if fail?
    MsgBox "Fail dac autocal."
End If
Call ADS_MUX2(Old_Save_IN_P2, Old_Save_IN_N2)
Call RunMnemonicCommand("CMD EN_ADS ON")

End Sub

Public Sub Write_DAC_C_Cal(set_voltage, OutputFormat As Integer)
Old_Save_IN_N2 = Save_IN_N2
Old_Save_IN_P2 = Save_IN_P2

Call RunMnemonicCommand("CMD EN_ADS OFF")

Call ADS_MUX2("GND", "DAC")
Call Write_DAC_C_Fast(set_voltage, OutputFormat) 'initial setting

pause (0.3) 'wait 300ms for ads1100 to do 16 bit conversion
X1 = -Read_ADS1100_2(OutputFormat)
Error_vol = X1 - set_voltage
New_Set_Voltage = set_voltage - Error_vol
Call Write_DAC_C_Fast(New_Set_Voltage, OutputFormat) 'first adjustment setting

pause (0.3)  'wait 300ms for ads1100 to do 16 bit conversion
X2 = -Read_ADS1100_2(OutputFormat)
Error_vol = X2 - set_voltage

If Abs(Error_vol) > 0.0002 Then 'optional second adjustment
    New_Set_Voltage = New_Set_Voltage - Error_vol
    Call Write_DAC_C_Fast(New_Set_Voltage, OutputFormat)
    pause (0.3)
    X3 = -Read_ADS1100_2(OutputFormat)
    Error_vol = X3 - set_voltage
End If
If Abs(Error_vol) > 0.0002 Then 'possable circuit damage if fail?
    MsgBox "Fail dac autocal."
End If
Call ADS_MUX2(Old_Save_IN_P2, Old_Save_IN_N2)
Call RunMnemonicCommand("CMD EN_ADS ON")

End Sub
Public Sub Write_DAC_B_Fast(InputVoltage, OutputFormat As Integer)

Dim i, ADS_Code




If OutputFormat = 1 Then
    InputVoltage_adj = (InputVoltage - inter_dac_B) / slope_dac_B
ElseIf OutputFormat = 2 Then
    InputVoltage_adj = (InputVoltage - inter_dac_B3) / slope_dac_B3
Else
    InputVoltage_adj = InputVoltage
End If


DAC_Code = (InputVoltage_adj) * 65535 / (Vref)
DAC_MSB = ((DAC_Code) And (65280)) / 256
DAC_LSB = (DAC_Code) And (255)
Call FillFields("I2C CH2 S 98 ACKS 12 ACKS " + Hex(DAC_MSB) + " ACKS " + Hex(DAC_LSB) + " ACKS P")
For i = 0 To 31
DATA_BYTE(i) = DATA_BYTE(i)
Next i
Call ReadAndWriteToDevice2
Call InterpretResults
End Sub
Public Sub Write_DAC_C_Fast(InputVoltage, OutputFormat As Integer)

Dim i, ADS_Code



If OutputFormat = 1 Then
    InputVoltage_adj = (InputVoltage - inter_dac_C) / slope_dac_C
ElseIf OutputFormat = 2 Then
    InputVoltage_adj = (InputVoltage - inter_dac_C3) / slope_dac_C3
Else
    InputVoltage_adj = InputVoltage
End If


DAC_Code = (InputVoltage_adj) * 65535 / (Vref)
DAC_MSB = ((DAC_Code) And (65280)) / 256
DAC_LSB = (DAC_Code) And (255)
Call FillFields("I2C CH2 S 98 ACKS 14 ACKS " + Hex(DAC_MSB) + " ACKS " + Hex(DAC_LSB) + " ACKS P")
For i = 0 To 31
DATA_BYTE(i) = DATA_BYTE(i)
Next i
Call ReadAndWriteToDevice2
Call InterpretResults
End Sub
Public Sub WriteEEPROM(d_value As Double, address As Integer)
first_address = Int(address * 3) - 1
second_address = first_address + 1
third_address = first_address + 2

If (d_value > 9.999998) Or (d_value < -9.999998) Then GoTo err_trap

If d_value < 0 Then
    ee_code = Int((2 ^ 24) + (2 ^ 23) * (d_value / 10))
    MSB = (ee_code And 16711680) / 2 ^ 16
    MSB_m1 = (ee_code And 65280) / 2 ^ 8
    LSB = (ee_code And 255)
Else
    ee_code = Int((2 ^ 23) * d_value / 10)
    MSB = (ee_code And 16711680) / 2 ^ 16
    MSB_m1 = (ee_code And 65280) / 2 ^ 8
    LSB = (ee_code And 255)
End If

Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(first_address) + " ACKS " + Hex(MSB) + " ACKS P")
Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(second_address) + " ACKS " + Hex(MSB_m1) + " ACKS P")
Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(third_address) + " ACKS " + Hex(LSB) + " ACKS P")
Call pause(0.1)
Exit Sub
err_trap:
MsgBox "Error in write EEPROM"

End Sub
Public Function ReadEEPROM(address As Integer)
check_third_address = 3
If check_third_address >= &H1FFF& Then
    MsgBox "you have exceded the size of the eeprom."
    GoTo err_trap2:
End If


first_address_msb = (Int(address * 3)) And (&HF00&)
second_address_msb = (Int(address * 3) + 1) And (&HF00&)
third_address_msb = (Int(address * 3) + 2) And (&HF00&)


first_address = (Int(address * 3)) - first_address_msb
second_address = (Int(address * 3) + 1) - second_address_msb
third_address = (Int(address * 3) + 2) - third_address_msb

first_address_msb = Shift_Right(first_address_msb, 8)
second_address_msb = Shift_Right(second_address_msb, 8)
third_address_msb = Shift_Right(third_address_msb, 8)

Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(first_address) + " ACKS P S AF ACKS R ACKS P")
d_value1 = ReadData(0)
Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(second_address) + " ACKS P S AF ACKS R ACKS P")
d_value2 = ReadData(0)
Call RunMnemonicCommand("I2C CH2 S AE ACKS 00 ACKS " + Hex(third_address) + " ACKS P S AF ACKS R ACKS P")
d_value3 = ReadData(0)

d_value = d_value1 * (2 ^ 16) + d_value2 * (2 ^ 8) + d_value3
'MsgBox d_value And (2 ^ 23)
If ((d_value) And (2 ^ 23)) <> 0 Then
    ReadEEPROM = 10 * (d_value - (2 ^ 24)) / (2 ^ 23)
Else
    ReadEEPROM = 10 * d_value / (2 ^ 23)

End If
ReadEEPROM = Round(ReadEEPROM, 6)
Exit Function

err_trap2:
MsgBox "Error in read EEPROM"
End Function

Public Sub Write_DAC_D_Fast(InputVoltage, OutputFormat As Integer)

Dim i, ADS_Code



If OutputFormat = 1 Then
    InputVoltage_adj = (InputVoltage - inter_dac_D) / slope_dac_D
ElseIf OutputFormat = 2 Then
    InputVoltage_adj = (InputVoltage - inter_dac_D3) / slope_dac_D3
Else
    InputVoltage_adj = InputVoltage
End If


DAC_Code = (InputVoltage_adj) * 65535 / (Vref)
DAC_MSB = ((DAC_Code) And (65280)) / 256
DAC_LSB = (DAC_Code) And (255)
Call FillFields("I2C CH2 S 98 ACKS 16 ACKS " + Hex(DAC_MSB) + " ACKS " + Hex(DAC_LSB) + " ACKS P")
For i = 0 To 31
DATA_BYTE(i) = DATA_BYTE(i)
Next i
Call ReadAndWriteToDevice2
Call InterpretResults
End Sub
Public Function EngineeringVal(inStrDec As String) As Double
    Dim i As Integer
    Dim ch As String * 1
    Dim strNum As String
    
    If inStrDec = "" Then   'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    'kill leading blank
    strNum = ""
     For i = 1 To Len(inStrDec)
        ch = Mid(inStrDec, i, 1)
        If (ch <> " ") Then
            strNum = strNum & ch
            leading_number_found = 1
        End If
    Next i
   inStrDec = strNum
    
    strNum = ""
    i = 0
    For i = 1 To Len(inStrDec)
        ch = Mid(inStrDec, i, 1)
        
        If (ch >= "0" And ch <= "9") Or ch = "." Or ch = "," _
            Or UCase(ch) = "E" Or ch = "+" Or ch = "-" Then
            strNum = strNum & ch
        Else
            Exit For    'break the loop if the char is not a digit
        End If
    Next i
    If strNum = "" Then     'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    EngineeringVal = CDbl(strNum)
    If i > Len(inStrDec) Then Exit Function 'exit if we reached
                                        'the end of the string
    Select Case ch
    Case "K", "k"
        EngineeringVal = EngineeringVal * 1000#
    Case "M"
        EngineeringVal = EngineeringVal * 1000000#
    Case "G", "t"
        EngineeringVal = EngineeringVal * 1000000000#
    Case "T", "t"
        EngineeringVal = EngineeringVal * 1000000000000#
    Case "m"
        EngineeringVal = EngineeringVal * 0.001
    Case "U", "u"
        EngineeringVal = EngineeringVal * 0.000001
    Case "N", "n"
        EngineeringVal = EngineeringVal * 0.000000001
    Case "P", "p"
        EngineeringVal = EngineeringVal * 0.000000000001
    Case "F", "f"
        EngineeringVal = EngineeringVal * 0.000000000000001
    End Select
End Function
Public Sub pause(PauseTime)
Dim start, roll_over
start = Timer   ' Set start time.
roll_over = Timer   ' Set start time.
    Do While (Timer < start + PauseTime) And (roll_over >= start)
        'DoEvents    ' Yield to other processes.
        roll_over = Timer
    Loop
    

End Sub

Public Sub pause_allow_events(PauseTime)
Dim start, roll_over
start = Timer   ' Set start time.
roll_over = Timer   ' Set start time.
    Do While (Timer < start + PauseTime) And (roll_over >= start)
         DoEvents    ' Yield to other processes.
        roll_over = Timer
    Loop
    

End Sub

Public Sub RunMnemonicCommand(MnemonicCommand$)
Dim i
If USB_Disconnected = True Then Exit Sub

Call FillFields(MnemonicCommand$)
If ErrorMsg = "" Then
    Call ReadAndWriteToDevice2
    Call InterpretResults
    Call DisplayIO2
    
    If DataFromUSB(31) <> (DATA_BYTE(31) + 1) Then
        'MsgBox "USB Communication problem -- The TUSB3210 is not responding"
        'Call Re_ReadDevice2
            Call ReadAndWriteToDevice2
            Call InterpretResults
            Call DisplayIO2
               USB_Read_Error = False

        If DataFromUSB(31) = (DATA_BYTE(31) + 1) Then
                'MsgBox "re-read worked"
        Else
                    frmUSB_Com_Prob.Show 1

               'MsgBox "re-read didn't work"
               'USB_Read_Error = True
        End If
    End If
End If
End Sub
Public Sub DisplayIO()
For i = 0 To 31
        frmMainDutWriter.Text1(i).Text = Hex(DATA_BYTE(i))
Next i

For i = 0 To 31
frmMainDutWriter.Text13(i) = Hex$(DataFromUSB(i))
Next

frmMainDutWriter.Text9 = ""
For i = 0 To NumberOfReads - 1
frmMainDutWriter.Text9 = frmMainDutWriter.Text9 + Hex$(ReadData(i)) + " "
Next i

frmMainDutWriter.Text10 = ""
For i = 0 To NumberOfACKS - 1
frmMainDutWriter.Text10 = frmMainDutWriter.Text10 + Hex$(ACK_Responce(jj)) + " "
Next i


End Sub
Public Sub InitDutWriter()

On Error GoTo SkipInit


Open App.Path + "\" + "EVM_Address_Settings.csv" For Input As #4
Input #4, MyProductID
Close #4
If MyProductID = "" Then GoTo SkipInit:

Open App.Path + "\" + "ControlEVM_Settings.csv" For Input As #4
Input #4, Vref
Input #4, ads_Conf
Close #4


Mux_Setting = 0
dac_autocal = 0
ads_Conf = 1
Exit Sub

SkipInit:
    DebugOn = 0
    MyProductID = &H2F90 '&H1234
    Vref = 5
    ads_Conf = 1
Close
End Sub
Public Sub InitDutWriter2()

On Error GoTo SkipInit


Call RunMnemonicCommand("CMD ON")
If USB_Read_Error = True Then
    MsgBox "Check connections to DAQ EVM."
Else
Call pause(0.2)
board_type = Int(ReadEEPROM(0) + 0.5) '1=analog, 2=digital
  If board_type <> 2 Then

    Call RunMnemonicCommand("CMD ON")
    slope_ads1P = ReadEEPROM(1)
    inter_ads1P = ReadEEPROM(2)
    slope_ads1M = ReadEEPROM(3)
    inter_ads1M = ReadEEPROM(4)
    slope_dac_A = ReadEEPROM(5)
    inter_dac_A = ReadEEPROM(6)
    slope_dac_B = ReadEEPROM(7)
    inter_dac_B = ReadEEPROM(8)
    
    slope_ads2P = ReadEEPROM(9)
    inter_ads2P = ReadEEPROM(10)
    slope_ads2M = ReadEEPROM(11)
    inter_ads2M = ReadEEPROM(12)
    slope_dac_C = ReadEEPROM(13)
    inter_dac_C = ReadEEPROM(14)
    slope_dac_D = ReadEEPROM(15)
    inter_dac_D = ReadEEPROM(16)

    slope_ads1P3 = ReadEEPROM(17)
    inter_ads1P3 = ReadEEPROM(18)
    slope_ads1M3 = ReadEEPROM(19)
    inter_ads1M3 = ReadEEPROM(20)
    slope_dac_A3 = ReadEEPROM(21)
    inter_dac_A3 = ReadEEPROM(22)
    slope_dac_B3 = ReadEEPROM(23)
    inter_dac_B3 = ReadEEPROM(24)
    
    slope_ads2P3 = ReadEEPROM(25)
    inter_ads2P3 = ReadEEPROM(26)
    slope_ads2M3 = ReadEEPROM(27)
    inter_ads2M3 = ReadEEPROM(28)
    slope_dac_C3 = ReadEEPROM(29)
    inter_dac_C3 = ReadEEPROM(30)
    slope_dac_D3 = ReadEEPROM(31)
    inter_dac_D3 = ReadEEPROM(32)
    
    
    Slope_I_loop = ReadEEPROM(33) / 1000
    inter_I_loop = ReadEEPROM(34) / 1000
    


    Call RunMnemonicCommand("CMD ILOOP OFF")
    Call RunMnemonicCommand("CMD EN_ADS ON")
    Call ADS_MUX1("OPEN", "OPEN")
    Call ADS_MUX2("OPEN", "OPEN")
End If
End If

If board_type <> 2 Then
    If slope_dac_D3 < 0.7 Then
        MsgBox "Invalid calibration information. "
        GoTo SkipInit
    End If
End If

Exit Sub

SkipInit:
    slope_ads1P = 1
    inter_ads1P = 0
    slope_ads1M = 1
    inter_ads1M = 0
    slope_dac_A = 1
    inter_dac_A = 0
    slope_dac_B = 1
    inter_dac_B = 0
    
    slope_ads2P = 1
    inter_ads2P = 0
    slope_ads2M = 1
    inter_ads2M = 0
    slope_dac_C = 1
    inter_dac_C = 0
    slope_dac_D = 1
    inter_dac_D = 0

    slope_ads1P3 = 1
    inter_ads1P3 = 0
    slope_ads1M3 = 1
    inter_ads1M3 = 0
    slope_dac_A3 = 1
    inter_dac_A3 = 0
    slope_dac_B3 = 1
    inter_dac_B3 = 0
    
    slope_ads2P3 = 1
    inter_ads2P3 = 0
    slope_ads2M3 = 1
    inter_ads2M3 = 0
    slope_dac_C3 = 1
    inter_dac_C3 = 0
    slope_dac_D3 = 1
    inter_dac_D3 = 0
    
    Slope_I_loop = 0.0066666666
    inter_I_loop = 0

    Call RunMnemonicCommand("CMD ILOOP OFF")


End Sub
Public Sub InterpretResults()
Dim jj
NumberOfReads = 0
NumberOfACKS = 0

        jj = 0
        For i = 0 To 31
            If (Word(i + 3) = "R") Then
                ReadData(jj) = DataFromUSB(i)
                jj = jj + 1
            End If
            If Word(i) = "MEAS" Then
                ReadData(jj) = DataFromUSB(i)
                jj = jj + 1
            End If
        Next
NumberOfReads = jj

jj = 0
        For i = 0 To 31
            If Word(i + 3) = "ACKS" Then
                ACK_Responce(jj) = DataFromUSB(i)
                jj = jj + 1
            End If
        Next

NumberOfACKS = jj

End Sub

Public Function WordValue(RawWord$, WordStatus$) As Byte
If WordStatus$ = "DATA" Then
WordValue = "&H" + RawWord$
End If

If WordStatus$ <> "DATA" Then
        Select Case RawWord$
        Case "L"
             WordValue = &H1
        Case "H"
             WordValue = &H2
        Case "S" 'I2C START
             WordValue = &H3
        Case "P" 'I2C STOP
             WordValue = &H4
        Case "ACKM" 'I2C ACK
             WordValue = &H5
        Case "ACKS" 'I2C ACK
             WordValue = &H6
        Case "R" 'SPI AND I2C READ
             WordValue = &HFF
        Case Else
            'WordValue = "INVALID word"
        End Select
End If

End Function
Public Function FindTheHid2() As Boolean
'Makes a series of API calls to locate the desired HID-class device.
'Returns True if the device is detected, False if not detected.

Dim count As Integer
Dim GUIDString As String
Dim HidGuid As GUID
Dim MemberIndex As Long

LastDevice = False
MyDeviceDetected = False

'Values for SECURITY_ATTRIBUTES structure:
Security.lpSecurityDescriptor = 0
Security.bInheritHandle = True
Security.nLength = Len(Security)

'******************************************************************************
'HidD_GetHidGuid
'Get the GUID for all system HIDs.
'Returns: the GUID in HidGuid.
'The routine doesn't return a value in Result
'but the routine is declared as a function for consistency with the other API calls.
'******************************************************************************

result = HidD_GetHidGuid(HidGuid)
Call DisplayResultOfAPICall2("GetHidGuid")

'Display the GUID.
GUIDString = _
    Hex$(HidGuid.Data1) & "-" & _
    Hex$(HidGuid.Data2) & "-" & _
    Hex$(HidGuid.Data3) & "-"

For count = 0 To 7
    'Ensure that each of the 8 bytes in the GUID displays two characters.
    If HidGuid.Data4(count) >= &H10 Then
        GUIDString = GUIDString & Hex$(HidGuid.Data4(count)) & " "
    Else
        GUIDString = GUIDString & "0" & Hex$(HidGuid.Data4(count)) & " "
    End If
Next count

If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  GUID for system HIDs: " & GUIDString + vbCrLf

'******************************************************************************
'SetupDiGetClassDevs
'Returns: a handle to a device information set for all installed devices.
'Requires: the HidGuid returned in GetHidGuid.
'******************************************************************************

DeviceInfoSet = SetupDiGetClassDevs _
    (HidGuid, _
    vbNullString, _
    0, _
    (DIGCF_PRESENT Or DIGCF_DEVICEINTERFACE))
    
Call DisplayResultOfAPICall2("SetupDiClassDevs")
DataString = GetDataString2(DeviceInfoSet, 32)

'******************************************************************************
'SetupDiEnumDeviceInterfaces
'On return, MyDeviceInterfaceData contains the handle to a
'SP_DEVICE_INTERFACE_DATA structure for a detected device.
'Requires:
'the DeviceInfoSet returned in SetupDiGetClassDevs.
'the HidGuid returned in GetHidGuid.
'An index to specify a device.
'******************************************************************************

'Begin with 0 and increment until no more devices are detected.
MemberIndex = 0

Do
    'The cbSize element of the MyDeviceInterfaceData structure must be set to
    'the structure's size in bytes. The size is 28 bytes.
    MyDeviceInterfaceData.cbSize = LenB(MyDeviceInterfaceData)
    result = SetupDiEnumDeviceInterfaces _
        (DeviceInfoSet, _
        0, _
        HidGuid, _
        MemberIndex, _
        MyDeviceInterfaceData)
    
    Call DisplayResultOfAPICall2("SetupDiEnumDeviceInterfaces")
    If result = 0 Then LastDevice = True
    
    'If a device exists, display the information returned.
    If result <> 0 Then
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  DeviceInfoSet for device #" & CStr(MemberIndex) & ": " + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  cbSize = " & CStr(MyDeviceInterfaceData.cbSize) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + _
            "  InterfaceClassGuid.Data1 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data1) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + _
            "  InterfaceClassGuid.Data2 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data2) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + _
            "  InterfaceClassGuid.Data3 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data3) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + _
            "  Flags = " & Hex$(MyDeviceInterfaceData.Flags) + vbCrLf
    
        
        '******************************************************************************
        'SetupDiGetDeviceInterfaceDetail
        'Returns: an SP_DEVICE_INTERFACE_DETAIL_DATA structure
        'containing information about a device.
        'To retrieve the information, call this function twice.
        'The first time returns the size of the structure in Needed.
        'The second time returns a pointer to the data in DeviceInfoSet.
        'Requires:
        'A DeviceInfoSet returned by SetupDiGetClassDevs and
        'an SP_DEVICE_INTERFACE_DATA structure returned by SetupDiEnumDeviceInterfaces.
        '*******************************************************************************
        
        MyDeviceInfoData.cbSize = Len(MyDeviceInfoData)
        result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           0, _
           0, _
           Needed, _
           0)
        
        DetailData = Needed
            
        Call DisplayResultOfAPICall2("SetupDiGetDeviceInterfaceDetail")
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  (OK to say too small)" + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Required buffer size for the data: " + Str(Needed) + vbCrLf
        
        'Store the structure's size.
        MyDeviceInterfaceDetailData.cbSize = _
            Len(MyDeviceInterfaceDetailData)
        
        'Use a byte array to allocate memory for
        'the MyDeviceInterfaceDetailData structure
        ReDim DetailDataBuffer(Needed)
        'Store cbSize in the first four bytes of the array.
        Call RtlMoveMemory _
            (DetailDataBuffer(0), _
            MyDeviceInterfaceDetailData, _
            4)
        
        'Call SetupDiGetDeviceInterfaceDetail again.
        'This time, pass the address of the first element of DetailDataBuffer
        'and the returned required buffer size in DetailData.
        result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           VarPtr(DetailDataBuffer(0)), _
           DetailData, _
           Needed, _
           0)
        
        Call DisplayResultOfAPICall2(" Result of second call: ")
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  MyDeviceInterfaceDetailData.cbSize: " & _
            CStr(MyDeviceInterfaceDetailData.cbSize) + vbCrLf
        
        'Convert the byte array to a string.
        DevicePathName = CStr(DetailDataBuffer())
        'Convert to Unicode.
        DevicePathName = StrConv(DevicePathName, vbUnicode)
        'Strip cbSize (4 bytes) from the beginning.
        DevicePathName = Right$(DevicePathName, Len(DevicePathName) - 4)
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Device pathname: " + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "    " & DevicePathName + vbCrLf
                
        '******************************************************************************
        'CreateFile
        'Returns: a handle that enables reading and writing to the device.
        'Requires:
        'The DevicePathName returned by SetupDiGetDeviceInterfaceDetail.
        '******************************************************************************
    
        HIDHandle = CreateFile _
            (DevicePathName, _
            GENERIC_READ Or GENERIC_WRITE, _
            (FILE_SHARE_READ Or FILE_SHARE_WRITE), _
            Security, _
            OPEN_EXISTING, _
            0&, _
            0)
            
        Call DisplayResultOfAPICall2("CreateFile")
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Returned handle: " & Hex$(HIDHandle) & "h" + vbCrLf
        
        'Now we can find out if it's the device we're looking for.
        
        '******************************************************************************
        'HidD_GetAttributes
        'Requests information from the device.
        'Requires: The handle returned by CreateFile.
        'Returns: an HIDD_ATTRIBUTES structure containing
        'the Vendor ID, Product ID, and Product Version Number.
        'Use this information to determine if the detected device
        'is the one we're looking for.
        '******************************************************************************
        
        'Set the Size property to the number of bytes in the structure.
        DeviceAttributes.Size = LenB(DeviceAttributes)
        result = HidD_GetAttributes _
            (HIDHandle, _
            DeviceAttributes)
            
        Call DisplayResultOfAPICall2("HidD_GetAttributes")
        If result <> 0 Then
            If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  HIDD_ATTRIBUTES structure filled without error." + vbCrLf
        Else
            If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Error in filling HIDD_ATTRIBUTES structure." + vbCrLf
        End If
    
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Structure size: " + Str(DeviceAttributes.Size) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Vendor ID: " + Hex$(DeviceAttributes.VendorID) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Product ID: " + Hex$(DeviceAttributes.ProductID) + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Version Number: " + Hex$(DeviceAttributes.VersionNumber) + vbCrLf
        
        'Find out if the device matches the one we're looking for.
        If (DeviceAttributes.VendorID = MyVendorID) And _
            (DeviceAttributes.ProductID = MyProductID) Then
                'It's the desired device.
                If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  My device detected" + vbCrLf
                MyDeviceDetected = True
        Else
                MyDeviceDetected = False
                'If it's not the one we want, close its handle.
                result = CloseHandle _
                    (HIDHandle)
                DisplayResultOfAPICall2 ("CloseHandle")
        End If
End If
    'Keep looking until we find the device or there are no more left to examine.
    MemberIndex = MemberIndex + 1
Loop Until (LastDevice = True) Or (MyDeviceDetected = True)

'Free the memory reserved for the DeviceInfoSet returned by SetupDiGetClassDevs.
result = SetupDiDestroyDeviceInfoList _
    (DeviceInfoSet)
Call DisplayResultOfAPICall2("DestroyDeviceInfoList")

If MyDeviceDetected = True Then
    FindTheHid2 = True
    'Learn the capabilities of the device
     Call GetDeviceCapabilities2
    'Get another handle for the overlapped ReadFiles.
    ReadHandle = CreateFile _
            (DevicePathName, _
            (GENERIC_READ Or GENERIC_WRITE), _
            (FILE_SHARE_READ Or FILE_SHARE_WRITE), _
            Security, _
            OPEN_EXISTING, _
            FILE_FLAG_OVERLAPPED, _
            0)

    Call DisplayResultOfAPICall2("CreateFile, ReadHandle")
    If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Returned handle: " & Hex$(ReadHandle) & "h" + vbCrLf
    Call PrepareForOverlappedTransfer2
Else
    If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " Device not found." + vbCrLf
End If

End Function

Public Sub PrepareForOverlappedTransfer2()

'******************************************************************************
'CreateEvent
'Creates an event object for the overlapped structure used with ReadFile.
'Requires a security attributes structure or null,
'Manual Reset = True (ResetEvent resets the manual reset object to nonsignaled),
'Initial state = True (signaled),
'and event object name (optional)
'Returns a handle to the event object.
'******************************************************************************

If EventObject = 0 Then
    EventObject = CreateEvent _
        (Security, _
        True, _
        True, _
        "")
End If
    
Call DisplayResultOfAPICall2("CreateEvent")
    
'Set the members of the overlapped structure.
HIDOverlapped.Offset = 0
HIDOverlapped.OffsetHigh = 0
HIDOverlapped.hEvent = EventObject
End Sub

Public Sub GetDeviceCapabilities2()

'******************************************************************************
'HidD_GetPreparsedData
'Returns: a pointer to a buffer containing information about the device's capabilities.
'Requires: A handle returned by CreateFile.
'There's no need to access the buffer directly,
'but HidP_GetCaps and other API functions require a pointer to the buffer.
'******************************************************************************

Dim ppData(29) As Byte
Dim ppDataString As Variant

'Preparsed Data is a pointer to a routine-allocated buffer.
result = HidD_GetPreparsedData _
    (HIDHandle, _
    PreparsedData)
Call DisplayResultOfAPICall2("HidD_GetPreparsedData")

'Copy the data at PreparsedData into a byte array.

result = RtlMoveMemory _
    (ppData(0), _
    PreparsedData, _
    30)
Call DisplayResultOfAPICall2("RtlMoveMemory")

ppDataString = ppData()
'Convert the data to Unicode.
ppDataString = StrConv(ppDataString, vbUnicode)

'******************************************************************************
'HidP_GetCaps
'Find out the device's capabilities.
'For standard devices such as joysticks, you can find out the specific
'capabilities of the device.
'For a custom device, the software will probably know what the device is capable of,
'so this call only verifies the information.
'Requires: The pointer to a buffer containing the information.
'The pointer is returned by HidD_GetPreparsedData.
'Returns: a Capabilites structure containing the information.
'******************************************************************************
result = HidP_GetCaps _
    (PreparsedData, _
    Capabilities)

Call DisplayResultOfAPICall2("HidP_GetCaps")
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Last error: " & ErrorString + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Usage: " & Hex$(Capabilities.Usage) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Usage Page: " & Hex$(Capabilities.UsagePage) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Input Report Byte Length: " + Str(Capabilities.InputReportByteLength) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Output Report Byte Length: " + Str(Capabilities.OutputReportByteLength) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Feature Report Byte Length: " + Str(Capabilities.FeatureReportByteLength) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Link Collection Nodes: " + Str(Capabilities.NumberLinkCollectionNodes) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Input Button Caps: " + Str(Capabilities.NumberInputButtonCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Input Value Caps: " + Str(Capabilities.NumberInputValueCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Input Data Indices: " + Str(Capabilities.NumberInputDataIndices) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Output Button Caps: " + Str(Capabilities.NumberOutputButtonCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Output Value Caps: " + Str(Capabilities.NumberOutputValueCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Output Data Indices: " + Str(Capabilities.NumberOutputDataIndices) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Feature Button Caps: " + Str(Capabilities.NumberFeatureButtonCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Feature Value Caps: " + Str(Capabilities.NumberFeatureValueCaps) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Number of Feature Data Indices: " + Str(Capabilities.NumberFeatureDataIndices) + vbCrLf

'******************************************************************************
'HidP_GetValueCaps
'Returns a buffer containing an array of HidP_ValueCaps structures.
'Each structure defines the capabilities of one value.
'This application doesn't use this data.
'******************************************************************************

'This is a guess. The byte array holds the structures.
Dim ValueCaps(1023) As Byte

result = HidP_GetValueCaps _
    (HidP_Input, _
    ValueCaps(0), _
    Capabilities.NumberInputValueCaps, _
    PreparsedData)
   
Call DisplayResultOfAPICall2("HidP_GetValueCaps")

'lstResults.AddItem "ValueCaps= " & GetDataString((VarPtr(ValueCaps(0))), 180)
'To use this data, copy the byte array into an array of structures.

'Free the buffer reserved by HidD_GetPreparsedData
result = HidD_FreePreparsedData _
    (PreparsedData)
Call DisplayResultOfAPICall2("HidD_FreePreparsedData")

End Sub


Public Function GetDataString2 _
    (address As Long, _
    Bytes As Long) _
As String

'Retrieves a string of length Bytes from memory, beginning at Address.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"

Dim Offset As Integer
Dim result$
Dim ThisByte As Byte

For Offset = 0 To Bytes - 1
    Call RtlMoveMemory(ByVal VarPtr(ThisByte), ByVal address + Offset, 1)
    If (ThisByte And &HF0) = 0 Then
        result$ = result$ & "0"
    End If
    result$ = result$ & Hex$(ThisByte) & " "
Next Offset

GetDataString = result$
End Function


Public Sub DisplayResultOfAPICall2(FunctionName As String)

'Display the results of an API call.

Dim ErrorString As String

If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "" + vbCrLf
ErrorString = GetErrorString2(Err.LastDllError)
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + FunctionName + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "  Result = " & ErrorString + vbCrLf

'Scroll to the bottom of the list box.
'frmMainDutWriter.lstResults.ListIndex = frmMainDutWriter.lstResults.ListCount - 1

End Sub


Public Function CheckWordStatus(WordToCheck$, InterfaceType$)
If Len(WordToCheck$) = 2 Then
    CheckFirstNib = Right$(WordToCheck$, 1)
    'MsgBox Asc(CheckFirstNib)
    first_nib = False
    If (Asc(CheckFirstNib) >= 48 And Asc(CheckFirstNib) <= 57) Or (Asc(CheckFirstNib) >= 65 And Asc(CheckFirstNib) <= 70) Or (Asc(CheckFirstNib) >= 97 And Asc(CheckFirstNib) <= 102) Then
        first_nib = True
    End If
    CheckSecondNib = Left$(WordToCheck$, 1)
    'MsgBox Asc(CheckSecondNib)
    second_nib = False
    If (Asc(CheckSecondNib) >= 48 And Asc(CheckSecondNib) <= 57) Or (Asc(CheckSecondNib) >= 65 And Asc(CheckSecondNib) <= 70) Or (Asc(CheckFirstNib) >= 97 And Asc(CheckFirstNib) <= 102) Then
        second_nib = True
    End If
    If first_nib = True And second_nib = True Then CheckWordStatus = "DATA"
End If
If Len(WordToCheck$) = 1 Then
    CheckFirstNib = Right$(WordToCheck$, 1)
    'MsgBox Asc(CheckFirstNib)
    If (Asc(CheckFirstNib) >= 48 And Asc(CheckFirstNib) <= 57) Or (Asc(CheckFirstNib) >= 65 And Asc(CheckFirstNib) <= 70) Or (Asc(CheckFirstNib) >= 97 And Asc(CheckFirstNib) <= 102) Then
    CheckWordStatus = "DATA"
    End If
End If

If CheckWordStatus <> "DATA" Then
    If InterfaceType$ = "SPI" Then
        Select Case WordToCheck$
        Case "L", "H", "R"
             CheckWordStatus = "COMMAND"
        Case Else
            CheckWordStatus = "INVALID SPI"
        End Select
    ElseIf InterfaceType$ = "I2C" Then
        Select Case WordToCheck$
        Case "S", "P", "ACKM", "ACKS", "R"
            CheckWordStatus = "COMMAND"
        Case Else
            CheckWordStatus = "INVALID I2C"
        End Select
    ElseIf InterfaceType$ = "ONE" Then
        Select Case WordToCheck$
        Case "R"
            CheckWordStatus = "COMMAND"
        Case Else
            CheckWordStatus = "INVALID ONE"
        End Select
    End If
End If
End Function

Public Sub FillFields(DutConfig$)
        Dim Interface_type As String
        Dim COUNTER_X As Double
        Dim i, iix, Start_word, End_Word, end_Start_word, CMD_CTR, Numb_Bytes As Integer
        Dim Numb_Words As Integer
        Dim OldWord(40) As String
        Dim Status_Of_Word As String
        Dim Aux_Mode
        
        If DebugOn = 2 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + DutConfig$ + vbCrLf
        Aux_Mode = 0
        ErrorMsg = ""
        For i = 1 To 40
        Word(i) = ""
        Next i
        If CHECK_BYTE < 254 Then
            CHECK_BYTE = CHECK_BYTE + 1
        Else
            CHECK_BYTE = 1
        End If
        For i = 0 To 31
            DATA_BYTE(i) = 0
        Next i

        Start_word = 1
        For i = 1 To Len(DutConfig$)
            If (Mid(DutConfig$, i, 1) = " ") And (Start_word <> 0) And (end_Start_word <> 0) Then
                End_Word = i
            End If
            If (Mid(DutConfig$, i, 1) = " ") And (Start_word = 0) Then
                Start_word = i
            End If
            If (Mid(DutConfig$, i, 1) <> " ") And (Start_word <> 0) And (end_Start_word = 0) Then
                end_Start_word = i
            End If

            If (i = Len(DutConfig$)) And (Start_word <> 0) And (end_Start_word <> 0) And (Mid(DutConfig$, i, 1) <> " ") Then
                End_Word = i + 1
            End If

            If (Start_word <> 0) And (End_Word <> 0) Then
                Word(Numb_Words) = Mid(DutConfig$, end_Start_word, (End_Word - end_Start_word))
                Start_word = End_Word
                End_Word = 0
                end_Start_word = 0
                Numb_Words = Numb_Words + 1
            End If
        Next
        If Numb_Words > 27 Then
            ErrorMsg = "Too many words in DutConfig$"
            GoTo ERROR_HANDLER
        End If
        Interface_type = Word(0)
        Select Case Word(0)
            Case "SPI"
                DATA_BYTE(0) = &H1
            Case "I2C"
                DATA_BYTE(0) = &H2
            Case "ONE"
                'Aux_Mode = 1
                DATA_BYTE(0) = &H3
            Case "CMD"
                Aux_Mode = 1 ' NOT A READ / WRITE BIT STRING
                DATA_BYTE(0) = &H4
           Case Else
                ErrorMsg = Word(0) + " is not a valid interface type."
                GoTo ERROR_HANDLER
        End Select
        
        If Interface_type = "ONE" Then ' DATA_BYTE(1) and DATA_BYTE(2) is not used on I2C mode.
            For IXX = 1 To Numb_Words - 1 'Shift words to match SPI format.
                OldWord(IXX) = Word(IXX)
            Next IXX
         
            For IXX = 1 To Numb_Words - 1 'Shift words to match SPI format.
                Word(IXX + 2) = OldWord(IXX)
            Next IXX
            Word(1) = ""
            Word(2) = ""
            Numb_Words = Numb_Words + 2
        End If
        
        If Interface_type = "I2C" Or Interface_type = "SPI" Then
            Select Case Word(1)
               Case "CH1"
                   DATA_BYTE(1) = &H1
               Case "CH2"
                   DATA_BYTE(1) = &H2
               Case Else
                   If Aux_Mode = 0 Then
                   ErrorMsg = Word(1) + " is not a valid interface channel."
                   GoTo ERROR_HANDLER
                   End If
            End Select
        End If
        
        If Interface_type = "I2C" Then ' DATA_BYTE(2) is not used on I2C mode.
            For IXX = 2 To Numb_Words - 1 'Shift words to match SPI format.
                OldWord(IXX) = Word(IXX)
            Next IXX
            For IXX = 2 To Numb_Words - 1 'Shift words to match SPI format.
                Word(IXX + 1) = OldWord(IXX)
            Next IXX
            Word(2) = ""
            Numb_Words = Numb_Words + 1
       End If
        
        If Interface_type = "SPI" Then
         Select Case Word(2)
            Case "BREH" 'BEFORE RISING
                DATA_BYTE(2) = &H1
            Case "BREL" 'BEFORE RISING
                DATA_BYTE(2) = &H11
            Case "AFEH" 'BEFORE FALLING
                DATA_BYTE(2) = &H2
            Case "AFEL" 'BEFORE FALLING
                DATA_BYTE(2) = &H12
            Case Else
                If Aux_Mode = 0 Then
                    ErrorMsg = Word(2) + " is not a valid edge definition."
                    GoTo ERROR_HANDLER
                End If
         End Select
        End If
        
If Aux_Mode = 0 Then
        Numb_Bytes = Numb_Words - 3
        DATA_BYTE(3) = Numb_Bytes
        CMD_CTR = 128
        For i = 0 To 7
            If CheckWordStatus(Word(i + 3), Interface_type) = "COMMAND" Then
                DATA_BYTE(4) = DATA_BYTE(4) Or CMD_CTR
            End If
            CMD_CTR = CMD_CTR / 2 ' 1
        Next
        CMD_CTR = 128
        For i = 8 To 15
            If CheckWordStatus(Word(i + 3), Interface_type) = "COMMAND" Then
                 DATA_BYTE(5) = DATA_BYTE(5) Or CMD_CTR
            End If
            CMD_CTR = CMD_CTR / 2 ' 1
        Next
        CMD_CTR = 128
        For i = 16 To Numb_Bytes
            If CheckWordStatus(Word(i + 3), Interface_type) = "COMMAND" Then
                 DATA_BYTE(6) = DATA_BYTE(6) Or CMD_CTR
            End If
            CMD_CTR = CMD_CTR / 2 ' 1
        Next
        
        For i = 0 To Numb_Bytes - 1
            Status_Of_Word = CheckWordStatus(Word(i + 3), Interface_type)
            If (Status_Of_Word = "DATA") Or (Status_Of_Word = "COMMAND") Then
                DATA_BYTE(i + 7) = WordValue(Word(i + 3), Status_Of_Word)
            Else
                ErrorMsg = Word(i + 3) + " is not a valid command or data." + vbCrLf + "Status_Of_Word=" + Status_Of_Word
                GoTo ERROR_HANDLER
            End If
        Next
 Else
    For i = 1 To Numb_Words - 1
        Select Case Word(i)
        Case "ON"
            DATA_BYTE(i) = 1
        Case "OFF"
            DATA_BYTE(i) = 2
        Case "MEAS"
            DATA_BYTE(i) = 3
        Case "CTRL"
            DATA_BYTE(i) = 4
            i = i + 1
            If Word(i) <> "" Then
                DATA_BYTE(i) = "&H" + Word(i)
            End If
         Case "MUX"
            DATA_BYTE(i) = 5
            i = i + 1
            If Word(i) <> "" Then
                DATA_BYTE(i) = "&H" + Word(i)
            End If
       Case "EN_ADS" 'was BIT1
            DATA_BYTE(i) = 6
            i = i + 1
            'If Word(i) <> "" Then
            '    DATA_BYTE(i) = "&H" + Word(i)
            'End If
            If Word(i) <> "ON" Then
                DATA_BYTE(i) = "&H00"
            ElseIf Word(i) <> "OFF" Then
                DATA_BYTE(i) = "&H01"
            Else
                ErrorMsg = Word(i) + " is not a valid Mnemomic!"
                GoTo ERROR_HANDLER
            End If

        Case "EN_ONE"
            DATA_BYTE(i) = 7
            i = i + 1
            If Word(i) <> "ON" Then
                DATA_BYTE(i) = "&H01"
            ElseIf Word(i) <> "OFF" Then
                DATA_BYTE(i) = "&H00"
            Else
                ErrorMsg = Word(i) + " is not a valid Mnemomic!"
                GoTo ERROR_HANDLER
            End If
        Case "EN_I2C"
            DATA_BYTE(i) = 8
            i = i + 1
            If Word(i) <> "ON" Then
                DATA_BYTE(i) = "&H01"
            ElseIf Word(i) <> "OFF" Then
                DATA_BYTE(i) = "&H00"
            Else
                ErrorMsg = Word(i) + " is not a valid Mnemomic!"
                GoTo ERROR_HANDLER
            End If
        Case "ILOOP"
            DATA_BYTE(i) = 9
            i = i + 1
            If Word(i) <> "ON" Then
                DATA_BYTE(i) = "&H01"
            ElseIf Word(i) <> "OFF" Then
                DATA_BYTE(i) = "&H00"
            Else
                ErrorMsg = Word(i) + " is not a valid Mnemomic!"
                GoTo ERROR_HANDLER
            End If
            
        Case "RS232"
            DATA_BYTE(i) = 10
            i = i + 1
            If Word(i) <> "ON" Then
                DATA_BYTE(i) = "&H01"
            ElseIf Word(i) <> "OFF" Then
                DATA_BYTE(i) = "&H00"
            Else
                ErrorMsg = Word(i) + " is not a valid Mnemomic!"
                GoTo ERROR_HANDLER
            End If
        Case "TEST"
            DATA_BYTE(i) = 11
        Case Else
            ErrorMsg = Word(i) + " is not a valid Mnemomic!"
            GoTo ERROR_HANDLER
        End Select
    Next i
End If
DATA_BYTE(31) = CHECK_BYTE

Exit Sub
ERROR_HANDLER:
MsgBox "Error in Mnemonic Command:" + vbCrLf + ErrorMsg + vbCrLf + "USB Mnemomic command will not be sent.", , "Error!"
End Sub
Public Sub DisplayIO2()
For i = 0 To 31
    frmUSB_DUT_Writer.txtToUSB(i).Text = Hex(DATA_BYTE(i))
Next i

For i = 0 To 31
    frmUSB_DUT_Writer.txtFromUSB(i) = Hex$(DataFromUSB(i))
Next

frmUSB_DUT_Writer.Text1 = ""
For i = 0 To NumberOfReads - 1
    frmUSB_DUT_Writer.Text1 = frmUSB_DUT_Writer.Text1 + Hex$(ReadData(i)) + " "
    If DebugOn = 2 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + Hex$(ReadData(i)) + " "
    If (DebugOn = 2) And (i = NumberOfReads - 1) Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + vbCrLf
Next i

frmUSB_DUT_Writer.Text2 = ""
For i = 0 To NumberOfACKS - 1
    frmUSB_DUT_Writer.Text2 = frmUSB_DUT_Writer.Text2 + Hex$(ACK_Responce(jj)) + " "
    If DebugOn = 2 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + Hex$(ACK_Responce(jj)) + " "
    If (DebugOn = 2) And (i = NumberOfACKS - 1) Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + vbCrLf
Next i


End Sub

Public Sub ReadAndWriteToDevice2()
'Sends two bytes to the device and reads two bytes back.

'Report Header
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "" + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "***** HID Test Report *****" + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + Format(Now, "general date") + vbCrLf


'If the device hasn't been detected or it timed out on a previous attempt
'to access it, look for the device.
If MyDeviceDetected = False Then
    MyDeviceDetected = FindTheHid2
End If

If MyDeviceDetected = True Then
       
    'Write a report to the device
    Call WriteReport2
    'The example firmware adds 1 to each received byte and sends the bytes back
    'to the host.
    'Read a report from the device.
    Call ReadReport2
Else
End If


End Sub
Public Sub Re_ReadDevice2()
'Sends two bytes to the device and reads two bytes back.

'Report Header
'If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "" + vbCrLf
'If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "***** HID Test Report *****" + vbCrLf
'If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + Format(Now, "general date") + vbCrLf


'If the device hasn't been detected or it timed out on a previous attempt
'to access it, look for the device.
'If MyDeviceDetected = False Then
 '   MyDeviceDetected = FindTheHid2
'End If

If MyDeviceDetected = True Then
       
    'Write a report to the device
   ' Call WriteReport2
    'The example firmware adds 1 to each received byte and sends the bytes back
    'to the host.
    'Read a report from the device.
    Call ReadReport2
Else
End If


End Sub
Public Sub ReadReport2()
'Read data from the device.

Dim count
Dim NumberOfBytesRead As Long
'Allocate a buffer for the report.
'Byte 0 is the report ID.
Dim ReadBuffer() As Byte
Dim UBoundReadBuffer As Integer

'******************************************************************************
'ReadFile
'Returns: the report in ReadBuffer.
'Requires: a device handle returned by CreateFile
'(for overlapped I/O, CreateFile must be called with FILE_FLAG_OVERLAPPED),
'the Input report length in bytes returned by HidP_GetCaps,
'and an overlapped structure whose hEvent member is set to an event object.
'******************************************************************************

Dim ByteValue As String
'The ReadBuffer array begins at 0, so subtract 1 from the number of bytes.
ReDim ReadBuffer(Capabilities.InputReportByteLength - 1)
'Scroll to the bottom of the list box.
'frmMainDutWriter.lstResults.ListIndex = frmMainDutWriter.lstResults.ListCount - 1

'Do an overlapped ReadFile.
'The function returns immediately, even if the data hasn't been received yet.
result = ReadFile _
    (ReadHandle, _
    ReadBuffer(0), _
    CLng(Capabilities.InputReportByteLength), _
    NumberOfBytesRead, _
    HIDOverlapped)
Call DisplayResultOfAPICall2("ReadFile")

If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "waiting for ReadFile" + vbCrLf
'Scroll to the bottom of the list box.
'frmMainDutWriter.lstResults.ListIndex = frmMainDutWriter.lstResults.ListCount - 1
bAlertable = True

'******************************************************************************
'WaitForSingleObject
'Used with overlapped ReadFile.
'Returns when ReadFile has received the requested amount of data or on timeout.
'Requires an event object created with CreateEvent
'and a timeout value in milliseconds.
'******************************************************************************
result = WaitForSingleObject _
    (EventObject, _
    6000)
Call DisplayResultOfAPICall2("WaitForSingleObject")

'Find out if ReadFile completed or timeout.
Select Case result
    Case WAIT_OBJECT_0
        'ReadFile has completed
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "ReadFile completed successfully." + vbCrLf
    Case WAIT_TIMEOUT
        'Timeout
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "Readfile timeout" + vbCrLf
        'Cancel the operation
        
        '*************************************************************
        'CancelIo
        'Cancels the ReadFile
        'Requires the device handle.
        'Returns non-zero on success.
        '*************************************************************
        result = CancelIo _
            (ReadHandle)
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "************ReadFile timeout*************" + vbCrLf
        If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "CancelIO" + vbCrLf
        Call DisplayResultOfAPICall2("CancelIo")
        'The timeout may have been because the device was removed,
        'so close any open handles and
        'set MyDeviceDetected=False to cause the application to
        'look for the device on the next attempt.
        CloseHandle (HIDHandle)
        Call DisplayResultOfAPICall2("CloseHandle (HIDHandle)")
        CloseHandle (ReadHandle)
        Call DisplayResultOfAPICall2("CloseHandle (ReadHandle)")
        MyDeviceDetected = False
    Case Else
        lstResults.AddItem "Readfile undefined error"
        MyDeviceDetected = False
End Select
    
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " Report ID: " + Str(ReadBuffer(0)) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " Report Data:" + vbCrLf

'frmMainDutWriter.txtBytesReceived.Text = ""
For count = 1 To UBound(ReadBuffer)
    'Add a leading 0 to values 0 - Fh.
    If Len(Hex$(ReadBuffer(count))) < 2 Then
        ByteValue = "0" & Hex$(ReadBuffer(count))
    Else
        ByteValue = Hex$(ReadBuffer(count))
    End If
    DataFromUSB(count - 1) = ReadBuffer(count)
    If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " " & ByteValue + vbCrLf
    'Display the received bytes in the text box.
    'frmMainDutWriter.txtBytesReceived.SelStart = Len(frmMainDutWriter.txtBytesReceived.Text)
    'frmMainDutWriter.txtBytesReceived.SelText = ByteValue & vbCrLf
Next count

'******************************************************************************
'ResetEvent
'Sets the event object in the overlapped structure to non-signaled.
'Requires a handle to the event object.
'Returns non-zero on success.
'******************************************************************************

Call ResetEvent(EventObject)
Call DisplayResultOfAPICall2("ResetEvent")
End Sub


Public Sub WriteReport2()
'Send data to the device.

Dim count As Integer
Dim NumberOfBytesRead As Long
Dim NumberOfBytesToSend As Long
Dim NumberOfBytesWritten As Long
Dim ReadBuffer() As Byte
Dim SendBuffer() As Byte

'The SendBuffer array begins at 0, so subtract 1 from the number of bytes.
ReDim SendBuffer(Capabilities.OutputReportByteLength - 1)

'******************************************************************************
'WriteFile
'Sends a report to the device.
'Returns: success or failure.
'Requires: the handle returned by CreateFile and
'The output report byte length returned by HidP_GetCaps
'******************************************************************************

'The first byte is the Report ID
SendBuffer(0) = 0

'The next bytes are data
For count = 1 To Capabilities.OutputReportByteLength - 1
    SendBuffer(count) = DATA_BYTE(count - 1)
Next count

NumberOfBytesWritten = 0

result = WriteFile _
    (HIDHandle, _
    SendBuffer(0), _
    CLng(Capabilities.OutputReportByteLength), _
    NumberOfBytesWritten, _
    0)
Call DisplayResultOfAPICall2("WriteFile")

If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " OutputReportByteLength = " + Str(Capabilities.OutputReportByteLength) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " NumberOfBytesWritten = " + Str(NumberOfBytesWritten) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " Report ID: " + Str(SendBuffer(0)) + vbCrLf
If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " Report Data:" + vbCrLf

For count = 1 To UBound(SendBuffer)
    If DebugOn = 1 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + " " & Hex$(SendBuffer(count)) + vbCrLf
Next count

End Sub

Private Function GetErrorString2 _
    (ByVal LastError As Long) _
As String

'Returns the error message for the last error.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"

Dim Bytes As Long
Dim ErrorString As String
ErrorString = String$(129, 0)
Bytes = FormatMessage _
    (FORMAT_MESSAGE_FROM_SYSTEM, _
    0&, _
    LastError, _
    0, _
    ErrorString$, _
    128, _
    0)
    
'Subtract two characters from the message to strip the CR and LF.
If Bytes > 2 Then
    GetErrorString = Left$(ErrorString, Bytes - 2)
End If

End Function





