Attribute VB_Name = "Calibration_Board"

Public Function ReadHP34401(ADDRESS_34401 As Integer)
'
'  ieee488 commands to read hp34401
'
    a$ = Space(255)
    'Dim ADDRLIST%(10)
    'ADDRLIST%(1) = ADDRESS_34401
    'ADDRLIST%(2) = NOADDR

    'Call EnableRemote(1, ADDRLIST%())
    ''Call Send(0, ADDRESS_34401, "MEAS:FRES?", DABend)
   ' Call EnableRemote(0, ADDRLIST%())
    Call Send(0, ADDRESS_34401, ":READ?", DABend)
    Call Receive(0, ADDRESS_34401, a$, STOPend)
     'MsgBox "a$ " + a$ + "*"
    If ((ibsta) And (EERR)) <> 0 Then MsgBox "IEEE error in HP34401!  ERROR NO = " + Str$(iberr)
        
    ReadHP34401 = EngineeringVal(a$)
End Function

Public Sub Set_U10_U11_Test_Bits(U10_Bits As Byte, U11_bits As Byte)
'
'  This is for the test (calibration) board only
'  U10 and U11 are 8 bit latches that control FET switches on the test board
'
Call RunMnemonicCommand("CMD CTRL " + Hex(U11_bits))
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 80 ACKM P") 'CLK HIGH
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("CMD CTRL " + Hex(U10_Bits))
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 40 ACKM P") 'CLK HIGH
Call RunMnemonicCommand("I2C CH2 S 7E ACKS 00 ACKM P") 'CLK LOW

End Sub
Public Sub Test_Board_Meas_Switch(ConnectString)
'
'  This is for the test (calibration) board only
'  Connects Bannana (hp34401) to ADS1 and ADS2
'
Select Case ConnectString
Case "C_Vdut"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H2)
Case "C_Vcc"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H1)
Case "C_15V"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H0, &H4)
Case "T_Vdut"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H20, &H0)
Case "T_Vcc"
    Call ADS_MUX1("", "GND")
    Call Set_U10_U11_Test_Bits(&H10, &H0)
Case "ADS1"
    'Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&HA, &H0)
Case "ADS2"
    'Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H5, &H0)
Case ""
    Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H0, &H0)
Case Else
    Call ADS_MUX1("", "")
    Call Set_U10_U11_Test_Bits(&H0, &H0)
    MsgBox "bad test_board_meas_switch"
End Select
End Sub
