Attribute VB_Name = "mod_Ina209"
Public Ina209Registers(50) As Long
Public RegBitLabel(50) As Variant
Public RegLegend(50) As String
Public RegBitTips(50) As Variant
Public Reg_ReadOnly(30) As Boolean
Public PGA_Gain As Double
Public Decmal209_Register(50) As Double
Public Updating_Controls As Boolean
Public sw1
Public Bus_Voltage_Range, ShuntFSR
Public ReadAddress, WriteAddress
Public MarkRegForWrite(50) As Boolean
Public OldReg(50) As Long
Public PowerLSB As Double
Public CurrentLSB As Double
Public Continuous_Read As Boolean

Public MaxPower As Double
Public m_nRealTimeCounter, real_time As Double
'Public disable_graph As Boolean
Public Log_open As Boolean
Public new_path As String
Public old_path As String
Public board_type As Double
Public Europe_Mode As Integer
Public read_once As Integer


Public Function Euro_US_string_fix(ByVal Inval As String) As String
If Len(Inval) = 0 Then Inval = 0


If Europe_Mode = 1 Then
    For iii = 1 To Len(Inval)
    chk_dp = Mid(Inval, iii, 1)
    If chk_dp = "." Then chk_dp = ","
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If

If Europe_Mode = 0 Then
    For iii = 1 To Len(Inval)
    chk_dp = Mid(Inval, iii, 1)
    If chk_dp = "," Then chk_dp = "."
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If

Euro_US_string_fix = new_NumFrmt
End Function
Public Function EuroFormat(ByVal Inval As Double, ByVal NumFrmt As String) As String
If Europe_Mode = 1 Then
    For iii = 1 To Len(NumFrmt)
    chk_dp = Mid(NumFrmt, iii, 1)
    If chk_dp = "." Then chk_dp = ","
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If
EuroFormat = Format(Inval, NumFrmt)
End Function


Public Sub Read_INA_Output_Bits()
Dim meas1
'Ctrl2 = 0
Call RunMnemonicCommand("CMD MEAS ")
OverLimit = Shift_Right(ReadData(0) And &H4&, 2)
Critical = Shift_Right(ReadData(0) And &H8&, 3)
Alert = Shift_Right(ReadData(0) And &H10&, 4)
Warning = ReadData(0) And &H1&
GPIO_Mon = Shift_Right(ReadData(0) And &H2&, 1)

formMain_INA209.txtOverlimit = Str(OverLimit)
formMain_INA209.txtOverlimit2 = Str(OverLimit)
formMain_INA209.txtCritical = Str(Critical)
formMain_INA209.txtCritical2 = Str(Critical)
formMain_INA209.txtAlert(0) = Str(Alert)
formMain_INA209.txtAlert(1) = Str(Alert)
formMain_INA209.txtWarning = Str(Warning)
formMain_INA209.txtWarning2 = Str(Warning)
formMain_INA209.textGPIO_Mon = Str(GPIO_Mon)

End Sub
Public Sub Save_Path(path_to_save$)
'
'  This sub saves the prevous path used for file saves / loads
'

On Error GoTo exit_p2:

Open App.Path + "\" + "path_info.txt" For Output As #35
Write #35, path_to_save$
Close #35
Exit Sub

exit_p2:
Close #35
old_path = ""

End Sub
Public Sub Load_Path()
'
'  This sub loads the prevous path used for file saves / loads
'

On Error GoTo exit_p1:

Open App.Path + "\" + "path_info.txt" For Input As #35
Input #35, old_path
Close #35
Exit Sub
exit_p1:
Close #35
old_path = ""
End Sub
Public Sub get_path(path_file$)
Dim i, find_Path$, done_ck
'
'  This sub returns the path only when given the path with the filename (i.e. the filename is striped off)
'
done_ck = 0
find_Path$ = ""
new_path$ = ""
'n_loops = Len(path_file$)
For i = Len(path_file$) To 1 Step -1
    find_Path$ = Left$(path_file$, i)
    If Right$(find_Path$, 1) = "\" And done_ck = 0 Then 'look for left most "\" this is the end of the path
       new_path$ = find_Path$
       done_ck = 1 'ignore other loops
    End If
Next i
End Sub

Public Sub config_chart1()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA209.Pesgo1.PlottingMethod = 0 'GPM_POINTSPLUSLINE'was
    formMain_INA209.Pesgo1.ShowAnnotations = True

    formMain_INA209.Pesgo1.Subsets = 1
    formMain_INA209.Pesgo1.Points = 100
    formMain_INA209.Pesgo1.SubsetLabels(0) = "Bus Voltage"
    'formMain_INA209.Pesgo1.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA209.Pesgo1.SubsetColors(1) = &HFF&
   '  formmain_ina209.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_ina209.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA209.Pesgo1.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA209.Pesgo1.ManualMinY = 0 'was 1
    formMain_INA209.Pesgo1.ManualMaxY = 32 'was 100
 
    '** Set Manual X scale **'
    formMain_INA209.Pesgo1.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA209.Pesgo1.ManualMinX = 1
    formMain_INA209.Pesgo1.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA209.Pesgo1.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA209.Pesgo1.XData(0, 0) = 0
    formMain_INA209.Pesgo1.XData(0, 1) = 0
    formMain_INA209.Pesgo1.XData(0, 2) = 0
    formMain_INA209.Pesgo1.XData(0, 3) = 0
    formMain_INA209.Pesgo1.YData(0, 0) = 0
    formMain_INA209.Pesgo1.YData(0, 1) = 0
    formMain_INA209.Pesgo1.YData(0, 2) = 0
    formMain_INA209.Pesgo1.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA209.Pesgo1.MainTitle = "Bus Voltage vs Time"
    formMain_INA209.Pesgo1.SubTitle = ""
    formMain_INA209.Pesgo1.NoRandomPointsToExport = True
    formMain_INA209.Pesgo1.FocalRect = False
    formMain_INA209.Pesgo1.AllowBar = False
    formMain_INA209.Pesgo1.AllowPopup = False
    formMain_INA209.Pesgo1.DeskColor = RGB(192, 192, 192)

    formMain_INA209.Pesgo1.PEactions = 0
    
    formMain_INA209.Pesgo1.XAxisLabel = "Time (sec)"
    formMain_INA209.Pesgo1.YAxisLabel = "Voltage (V)"
     formMain_INA209.Pesgo1.MarkDataPoints = True
    'formmain_ina209.Pesgo1.MinimumPointSize = PEMPS_LARGE
    formMain_INA209.Pesgo1.FontSize = PEFS_LARGE
      
  
End Sub
Public Sub config_chart2()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA209.Pesgo2.PlottingMethod = 0 'GPM_POINTSPLUSLINE
    formMain_INA209.Pesgo2.ShowAnnotations = True

    formMain_INA209.Pesgo2.Subsets = 1
    formMain_INA209.Pesgo2.Points = 100
    formMain_INA209.Pesgo2.SubsetLabels(0) = "Shunt Current vs Time"
    'formMain_INA209.Pesgo2.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA209.Pesgo2.SubsetColors(1) = &HFF&
   '  formmain_ina209.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_ina209.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA209.Pesgo2.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA209.Pesgo2.ManualMinY = 0 'was 1
    formMain_INA209.Pesgo2.ManualMaxY = EngineeringVal(formMain_INA209.txtMaxI) 'was 100
 
    '** Set Manual X scale **'
    formMain_INA209.Pesgo2.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA209.Pesgo2.ManualMinX = 1
    formMain_INA209.Pesgo2.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA209.Pesgo2.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA209.Pesgo2.XData(0, 0) = 0
    formMain_INA209.Pesgo2.XData(0, 1) = 0
    formMain_INA209.Pesgo2.XData(0, 2) = 0
    formMain_INA209.Pesgo2.XData(0, 3) = 0
    formMain_INA209.Pesgo2.YData(0, 0) = 0
    formMain_INA209.Pesgo2.YData(0, 1) = 0
    formMain_INA209.Pesgo2.YData(0, 2) = 0
    formMain_INA209.Pesgo2.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA209.Pesgo2.MainTitle = "Shunt Current vs Time"
    formMain_INA209.Pesgo2.SubTitle = ""
    formMain_INA209.Pesgo2.NoRandomPointsToExport = True
    formMain_INA209.Pesgo2.FocalRect = False
    formMain_INA209.Pesgo2.AllowBar = False
    formMain_INA209.Pesgo2.AllowPopup = False
    formMain_INA209.Pesgo2.DeskColor = RGB(192, 192, 192)

    formMain_INA209.Pesgo2.PEactions = 0
    
    formMain_INA209.Pesgo2.XAxisLabel = "Time (sec)"
    formMain_INA209.Pesgo2.YAxisLabel = "Current (A)"
     formMain_INA209.Pesgo2.MarkDataPoints = True
    'formmain_ina209.Pesgo1.MinimumPointSize = PEMPS_LARGE
    formMain_INA209.Pesgo2.FontSize = PEFS_LARGE
      
  
End Sub

Public Sub config_chart3()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA209.Pesgo3.PlottingMethod = 0 'GPM_POINTSPLUSLINE
    formMain_INA209.Pesgo3.ShowAnnotations = True

    formMain_INA209.Pesgo3.Subsets = 1
    formMain_INA209.Pesgo3.Points = 100
    formMain_INA209.Pesgo3.SubsetLabels(0) = "Power"
    'formMain_INA209.Pesgo3.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA209.Pesgo3.SubsetColors(1) = &HFF&
   '  formmain_ina209.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_ina209.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA209.Pesgo3.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA209.Pesgo3.ManualMinY = 0 'was 1
    formMain_INA209.Pesgo3.ManualMaxY = EngineeringVal(formMain_INA209.txtMaxPower) 'was 100
 
    '** Set Manual X scale **'
    formMain_INA209.Pesgo3.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA209.Pesgo3.ManualMinX = 1
    formMain_INA209.Pesgo3.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA209.Pesgo3.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA209.Pesgo3.XData(0, 0) = 0
    formMain_INA209.Pesgo3.XData(0, 1) = 0
    formMain_INA209.Pesgo3.XData(0, 2) = 0
    formMain_INA209.Pesgo3.XData(0, 3) = 0
    formMain_INA209.Pesgo3.YData(0, 0) = 0
    formMain_INA209.Pesgo3.YData(0, 1) = 0
    formMain_INA209.Pesgo3.YData(0, 2) = 0
    formMain_INA209.Pesgo3.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA209.Pesgo3.MainTitle = "Power vs Time"
    formMain_INA209.Pesgo3.SubTitle = ""
    formMain_INA209.Pesgo3.NoRandomPointsToExport = True
    formMain_INA209.Pesgo3.FocalRect = False
    formMain_INA209.Pesgo3.AllowBar = False
    formMain_INA209.Pesgo3.AllowPopup = False
    formMain_INA209.Pesgo3.DeskColor = RGB(192, 192, 192)

    formMain_INA209.Pesgo3.PEactions = 0
    
    formMain_INA209.Pesgo3.XAxisLabel = "Time (sec)"
    formMain_INA209.Pesgo3.YAxisLabel = "Power (W)"
     formMain_INA209.Pesgo3.MarkDataPoints = True
    formMain_INA209.Pesgo3.FontSize = PEFS_LARGE
      
  
End Sub


Public Function Shift_Right(word_to_shift, no_positions)
Shift_Right = Int(word_to_shift / (2 ^ no_positions))
End Function
Public Function Shift_Left(word_to_shift, no_positions)
Shift_Left = Int(word_to_shift * (2 ^ no_positions))

End Function

Public Sub UpdateRegisterDisplay_Normal(Optional UpdateFlag As Boolean = True)
    Dim i As Integer    ' loop index
  With formMain_INA209.gridReg
    If .TextMatrix(1, 0) <> "00h" Then 'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "00h"
        .TextMatrix(1, 1) = " Config"
        .TextMatrix(2, 0) = "01h"
        .TextMatrix(2, 1) = " Status"
        .TextMatrix(3, 0) = "02h"
        .TextMatrix(3, 1) = " SMBus Alert Mask / Enable Control"
        .TextMatrix(4, 0) = "03h"
        .TextMatrix(4, 1) = " Shunt Voltage"
        .TextMatrix(5, 0) = "04h"
        .TextMatrix(5, 1) = " Bus Voltage"
        .TextMatrix(6, 0) = "05h"
        .TextMatrix(6, 1) = " Power"
        .TextMatrix(7, 0) = "06h"
        .TextMatrix(7, 1) = " Current / PGA"
        .TextMatrix(8, 0) = "07h"
        .TextMatrix(8, 1) = " Shunt + Peak"
        .TextMatrix(9, 0) = "08h"
        .TextMatrix(9, 1) = " Shunt - Peak"
         .TextMatrix(10, 0) = "09h"
         .TextMatrix(10, 1) = " Bus V Max Peak"
         .TextMatrix(11, 0) = "0Ah"
         .TextMatrix(11, 1) = " Bus V Low Peak"
         .TextMatrix(12, 0) = "0Bh"
         .TextMatrix(12, 1) = " Power Peak"
        .TextMatrix(13, 0) = "0Ch"
        .TextMatrix(13, 1) = " Shunt +Warning"
         .TextMatrix(14, 0) = "0Dh"
        .TextMatrix(14, 1) = " Shunt -Warning"
        .TextMatrix(15, 0) = "0Eh"
        .TextMatrix(15, 1) = " Power Warning"
        .TextMatrix(16, 0) = "0Fh"
        .TextMatrix(16, 1) = " Bus Over Voltage Warning"
        .TextMatrix(17, 0) = "10h"
        .TextMatrix(17, 1) = " Bus Under Voltage Warning"
        .TextMatrix(18, 0) = "11h"
        .TextMatrix(18, 1) = " Power Overlimit"
        .TextMatrix(19, 0) = "12h"
        .TextMatrix(19, 1) = " Bus Over Voltage Overlimit"
        .TextMatrix(20, 0) = "13h"
        .TextMatrix(20, 1) = " Bus Under Voltage Overlimit"
        .TextMatrix(21, 0) = "14h"
        .TextMatrix(21, 1) = " Critical DAC+"
        .TextMatrix(22, 0) = "15h"
        .TextMatrix(22, 1) = " Critical DAC-"
        .TextMatrix(23, 0) = "16h"
        .TextMatrix(23, 1) = " Full Scale Cal"
   End If
    'If UpdateFlag And (formMain_INA209.chkAutoSum = 1) Then
                'if checksum update is allowed
        'Call CalcCheckSumRegisters
    'End If
    For i = 0 To &H16&
        If OldReg(i) <> Ina209Registers(i) Then
            MarkRegForWrite(i) = True
        End If
    Next i
    
    For i = 0 To &H16&
         OldReg(i) = Ina209Registers(i)
    Next i
    
    For i = 0 To 22
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(Ina209Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(Ina209Registers(i), 0, False)
    Next i
    For i = 0 To &H16&
        Select Case i
        Case 0, 1, 2, &H16& 'skip -- no analog equ
        Case Else
        Call UpdateDecimal(i)
        .TextMatrix(i + 1, 4) = Decmal209_Register(i)
        End Select
    Next i
  End With
  Call formMain_INA209.ShowRegDetails       ' update those
  Call Update_Controls 'update controls based on reg values

 Updating_Controls = True

 formMain_INA209.txt_Shunt_V_Pos_Warn.Text = Euro_US_string_fix(Decmal209_Register(&HC&))
 formMain_INA209.txt_Shunt_V_Neg_Warn.Text = Euro_US_string_fix(Decmal209_Register(&HD&))
 formMain_INA209.txtShunt(0).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(1).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(2).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(3).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtVbus(0).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(1).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(2).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(3).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(4).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(5).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtPower(0).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPower(1).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPower(2).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPowerWarning.Text = Euro_US_string_fix(Decmal209_Register(&HE&))
 formMain_INA209.txt_Vbus_Over_Voltage.Text = Euro_US_string_fix(Decmal209_Register(&HF&))
 formMain_INA209.txt_Vbus_Under_Voltage.Text = Euro_US_string_fix(Decmal209_Register(&H10&))
 formMain_INA209.txtPowerOverLimit.Text = Euro_US_string_fix(Decmal209_Register(&H11&))
 formMain_INA209.txt_Vbus_Over_Lim.Text = Euro_US_string_fix(Decmal209_Register(&H12&))
 formMain_INA209.txt_Vbus_Under_Lim.Text = Euro_US_string_fix(Decmal209_Register(&H13&))
 formMain_INA209.txtCritical_Dac_p.Text = Euro_US_string_fix(Decmal209_Register(&H14&))
 formMain_INA209.txtCritical_Dac_m.Text = Euro_US_string_fix(Decmal209_Register(&H15&))
 formMain_INA209.cmd_I_shunt.Text = Euro_US_string_fix(Decmal209_Register(6))
 'formMain_INA209.txtINA209_Current.Text = Euro_US_string_fix(Decmal209_Register(6))
 
 formMain_INA209.txtShunt(4) = Euro_US_string_fix(Decmal209_Register(&H3&))
 formMain_INA209.txtShunt(5) = (Ina209Registers(&H3&))  '1/21/08

 formMain_INA209.txtFSC = (Ina209Registers(&H16&))  '1/21/08
 formMain_INA209.txtCurrent2 = (Ina209Registers(&H6&))  '1/21/08
 formMain_INA209.txtVbus(6) = (Ina209Registers(&H4&))  '1/25/08
 formMain_INA209.txtPower(3) = (Ina209Registers(&H5&)) '1/25/08
 
 formMain_INA209.txtShuntPosPeak(0) = Euro_US_string_fix(Decmal209_Register(&H7&))
 formMain_INA209.txtShuntNegPeak(0) = Euro_US_string_fix(Decmal209_Register(&H8&))
 formMain_INA209.txtPowerPeak(0) = Euro_US_string_fix(Decmal209_Register(&HB&))
 formMain_INA209.txtBusMaxPeak(0) = Euro_US_string_fix(Decmal209_Register(&H9&))
 formMain_INA209.txtBusMinPeak(0) = Euro_US_string_fix(Decmal209_Register(&HA&))
 
  formMain_INA209.txtShuntPosPeak(1) = (Ina209Registers(&H7&))
 formMain_INA209.txtShuntNegPeak(1) = (Ina209Registers(&H8&))
 formMain_INA209.txtPowerPeak(1) = (Ina209Registers(&HB&))
 formMain_INA209.txtBusMaxPeak(1) = (Ina209Registers(&H9&))
 formMain_INA209.txtBusMinPeak(1) = (Ina209Registers(&HA&))

 formMain_INA209.txtWarnFlag(0) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H2000&), 13)) 'WP -power warn
 formMain_INA209.txtWarnFlag(1) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H8000&), 15)) 'WOV
 formMain_INA209.txtWarnFlag(2) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H4000&), 14)) 'WUV
 formMain_INA209.txtWarnFlag(3) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H1000&), 12)) 'WS+
 formMain_INA209.txtWarnFlag(4) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H800&), 11)) 'WS-
 
 formMain_INA209.txtOverFlag(0) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H100&), 8)) 'OLP
 formMain_INA209.txtOverFlag(1) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H400&), 10)) 'OLOV
 formMain_INA209.txtOverFlag(2) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H200&), 9)) 'OLUV
 
 formMain_INA209.txtCriticalFlag(0) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H80&), 7)) 'CRIT+
 formMain_INA209.txtCriticalFlag(1) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H40&), 6)) 'CRIT-

 
 formMain_INA209.txtAllFlags(0) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H8000&), 15)) 'WOV
 formMain_INA209.txtAllFlags(1) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H4000&), 14)) 'WUV
 formMain_INA209.txtAllFlags(2) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H2000&), 13)) 'WP -power warn
 formMain_INA209.txtAllFlags(3) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H1000&), 12)) 'WS+
 formMain_INA209.txtAllFlags(4) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H800&), 11)) 'WS-
 formMain_INA209.txtAllFlags(5) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H400&), 10)) 'OLOV
 formMain_INA209.txtAllFlags(6) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H200&), 9)) 'OLUV
 formMain_INA209.txtAllFlags(7) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H100&), 8)) 'OLP
 formMain_INA209.txtAllFlags(8) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H80&), 7)) 'CRIT+
 formMain_INA209.txtAllFlags(9) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H40&), 6)) 'CRIT-
 formMain_INA209.txtAllFlags(10) = Euro_US_string_fix(Shift_Right((Ina209Registers(1) And &H20&), 5)) 'CNVR
 
 

 Updating_Controls = False


End Sub
Public Sub UpdateRegisterDisplay(Optional UpdateFlag As Boolean = True)

If formMain_INA209.mnuEngineeringMode.Checked = False Then
    Call UpdateRegisterDisplay_Normal(UpdateFlag)
Else
    Call UpdateRegisterDisplay_eng(UpdateFlag)
End If

End Sub

Public Sub UpdateRegisterDisplay_eng(Optional UpdateFlag As Boolean = True)

    Dim i As Integer    ' loop index
  With formMain_INA209.gridReg
     If .TextMatrix(28, 1) <> " ADC2" Then  'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "00h"
        .TextMatrix(1, 1) = " Config"
        .TextMatrix(2, 0) = "01h"
        .TextMatrix(2, 1) = " Status"
        .TextMatrix(3, 0) = "02h"
        .TextMatrix(3, 1) = " SMBus Alert Mask / Enable Control"
        .TextMatrix(4, 0) = "03h"
        .TextMatrix(4, 1) = " Shunt Voltage"
        .TextMatrix(5, 0) = "04h"
        .TextMatrix(5, 1) = " Bus Voltage"
        .TextMatrix(6, 0) = "05h"
        .TextMatrix(6, 1) = " Power"
        .TextMatrix(7, 0) = "06h"
        .TextMatrix(7, 1) = " Current / PGA"
        .TextMatrix(8, 0) = "07h"
        .TextMatrix(8, 1) = " Shunt + Peak"
        .TextMatrix(9, 0) = "08h"
        .TextMatrix(9, 1) = " Shunt - Peak"
         .TextMatrix(10, 0) = "09h"
         .TextMatrix(10, 1) = " Bus V Max Peak"
         .TextMatrix(11, 0) = "0Ah"
         .TextMatrix(11, 1) = " Bus V Low Peak"
         .TextMatrix(12, 0) = "0Bh"
         .TextMatrix(12, 1) = " Power Peak"
        .TextMatrix(13, 0) = "0Ch"
        .TextMatrix(13, 1) = " Shunt +Warning"
         .TextMatrix(14, 0) = "0Dh"
        .TextMatrix(14, 1) = " Shunt -Warning"
        .TextMatrix(15, 0) = "0Eh"
        .TextMatrix(15, 1) = " Power Warning"
        .TextMatrix(16, 0) = "0Fh"
        .TextMatrix(16, 1) = " Bus Over Voltage Warning"
        .TextMatrix(17, 0) = "10h"
        .TextMatrix(17, 1) = " Bus Under Voltage Warning"
        .TextMatrix(18, 0) = "11h"
        .TextMatrix(18, 1) = " Power Overlimit"
        .TextMatrix(19, 0) = "12h"
        .TextMatrix(19, 1) = " Bus Over Voltage Overlimit"
        .TextMatrix(20, 0) = "13h"
        .TextMatrix(20, 1) = " Bus Under Voltage Overlimit"
        .TextMatrix(21, 0) = "14h"
        .TextMatrix(21, 1) = " Critical DAC+"
        .TextMatrix(22, 0) = "15h"
        .TextMatrix(22, 1) = " Critical DAC-"
        .TextMatrix(23, 0) = "16h"
        .TextMatrix(23, 1) = " Full Scale Cal"
        .TextMatrix(24, 0) = "17h"
        .TextMatrix(24, 1) = " Not Used"
        .TextMatrix(25, 0) = "18h"
        .TextMatrix(25, 1) = " Trim State"
        .TextMatrix(26, 0) = "19h"
        .TextMatrix(26, 1) = " Trim Data"
        .TextMatrix(27, 0) = "1Ah"
        .TextMatrix(27, 1) = " ADC1"
        .TextMatrix(28, 0) = "1Bh"
        .TextMatrix(28, 1) = " ADC2"
    End If
    For i = 0 To &H1B&
        If OldReg(i) <> Ina209Registers(i) Then
            MarkRegForWrite(i) = True
        End If
    Next i
    
    For i = 0 To &H1B&
         OldReg(i) = Ina209Registers(i)
    Next i
    
    For i = 0 To &H1B&
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(Ina209Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(Ina209Registers(i), 0, False)
    Next i
    For i = 0 To &H1B&
        Select Case i
        Case 0, 1, 2, &H16& 'skip -- no analog equ
        Case Else
        Call UpdateDecimal(i)
        .TextMatrix(i + 1, 4) = Decmal209_Register(i)
        End Select
    Next i
  End With
     Call formMain_INA209.ShowRegDetails       ' update those
     Call Update_Controls 'update controls based on reg values
 Updating_Controls = True

 formMain_INA209.txt_Shunt_V_Pos_Warn.Text = Euro_US_string_fix(Decmal209_Register(&HC&))
 formMain_INA209.txt_Shunt_V_Neg_Warn.Text = Euro_US_string_fix(Decmal209_Register(&HD&))
 formMain_INA209.txtShunt(0).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(1).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(2).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtShunt(3).Text = Euro_US_string_fix(Decmal209_Register(3))
 formMain_INA209.txtVbus(0).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(1).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(2).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(3).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(4).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtVbus(5).Text = Euro_US_string_fix(Decmal209_Register(4))
 formMain_INA209.txtPower(0).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPower(1).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPower(2).Text = Euro_US_string_fix(Decmal209_Register(5))
 formMain_INA209.txtPowerWarning.Text = Euro_US_string_fix(Decmal209_Register(&HE&))
 formMain_INA209.txt_Vbus_Over_Voltage.Text = Euro_US_string_fix(Decmal209_Register(&HF&))
 formMain_INA209.txt_Vbus_Under_Voltage.Text = Euro_US_string_fix(Decmal209_Register(&H10&))
 formMain_INA209.txtPowerOverLimit.Text = Euro_US_string_fix(Decmal209_Register(&H11&))
 formMain_INA209.txt_Vbus_Over_Lim.Text = Euro_US_string_fix(Decmal209_Register(&H12&))
 formMain_INA209.txt_Vbus_Under_Lim.Text = Euro_US_string_fix(Decmal209_Register(&H13&))
 formMain_INA209.txtCritical_Dac_p.Text = Euro_US_string_fix(Decmal209_Register(&H14&))
 formMain_INA209.txtCritical_Dac_m.Text = Euro_US_string_fix(Decmal209_Register(&H15&))
 formMain_INA209.cmd_I_shunt.Text = Euro_US_string_fix(Decmal209_Register(6))
  'formMain_INA209.txtINA209_Current.Text = Euro_US_string_fix(Decmal209_Register(6))

 formMain_INA209.txtShunt(4) = Euro_US_string_fix(Decmal209_Register(&H3&))
 formMain_INA209.txtShunt(5) = (Ina209Registers(&H3&))  '1/21/08
 
 formMain_INA209.txtFSC = (Ina209Registers(&H16&))  '1/21/08
 formMain_INA209.txtCurrent2 = (Ina209Registers(&H6&))  '1/21/08
 formMain_INA209.txtVbus(6) = (Ina209Registers(&H4&)) '1/25/08
 formMain_INA209.txtPower(3) = (Ina209Registers(&H5&)) '1/25/08
 
  formMain_INA209.txtShuntPosPeak(0) = Euro_US_string_fix(Decmal209_Register(&H7&))
 formMain_INA209.txtShuntNegPeak(0) = Euro_US_string_fix(Decmal209_Register(&H8&))
 formMain_INA209.txtPowerPeak(0) = Euro_US_string_fix(Decmal209_Register(&HB&))
 formMain_INA209.txtBusMaxPeak(0) = Euro_US_string_fix(Decmal209_Register(&H9&))
 formMain_INA209.txtBusMinPeak(0) = Euro_US_string_fix(Decmal209_Register(&HA&))
 
  formMain_INA209.txtShuntPosPeak(1) = (Ina209Registers(&H7&))
 formMain_INA209.txtShuntNegPeak(1) = (Ina209Registers(&H8&))
 formMain_INA209.txtPowerPeak(1) = (Ina209Registers(&HB&))
 formMain_INA209.txtBusMaxPeak(1) = (Ina209Registers(&H9&))
 formMain_INA209.txtBusMinPeak(1) = (Ina209Registers(&HA&))
Updating_Controls = False

End Sub

Public Sub Read_Ina209()
If formMain_INA209.mnuEngineeringMode.Checked = False Then
    Call Read_Ina209_Normal
Else
    Call Read_Ina209_ENG
End If

End Sub
       
Public Sub Read_Ina209_Normal()
'Call random_reg
For REG = 0 To &H16&
    Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(REG) + " ACKS P") 'set pointer
    If ACK_Responce(0) <> 0 Or ACK_Responce(1) <> 0 Then
        formMain_INA209.txtDutNotAck.Visible = True
        formMain_INA209.txtDutNotAck.Text = "INA209 Did Not Acknowledge!"
    Else
        formMain_INA209.txtDutNotAck.Visible = False
    End If
    Call RunMnemonicCommand("I2C CH1 S " + Hex(ReadAddress) + " ACKS R ACKM R ACKM P")
    Ina209Registers(REG) = ReadData(0) * &H100& + ReadData(1)
    If ACK_Responce(0) <> 0 Then
        formMain_INA209.txtDutNotAck.Visible = True
        formMain_INA209.txtDutNotAck.Text = "INA209 Did Not Acknowledge!"
    Else
        formMain_INA209.txtDutNotAck.Visible = False
    End If
Next REG

For REG = 0 To &H16&
    Call UpdateDecimal(REG)
Next REG
Call Read_INA_Output_Bits

Call UpdateRegisterDisplay

End Sub
Public Sub DoGraph()
   ' Call Read_Ina209
   ' Call Read_INA_Output_Bits
   ' DoEvents

    
    
    'm_nRealTimeCounter = 0

    
    
    '** Update new data at current index  **'
     formMain_INA209.Pesgo1.YData(0, m_nRealTimeCounter) = Decmal209_Register(4)
     'Pesgo1.YData(1, m_nRealTimeCounter) = Decmal209_Register(9)
     formMain_INA209.Pesgo1.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
     'Pesgo1.XData(1, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA209.Pesgo1.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA209.Pesgo1.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA209.Pesgo1.VertLineAnnotationColor(0) = QBColor(12)

   
    '** Update image and force paint **'
     formMain_INA209.Pesgo1.PEnarg1 = 0
     formMain_INA209.Pesgo1.PEnarg2 = 0
     formMain_INA209.Pesgo1.PEactions = 0  '// Calls PEresetimage
    
    
    
    
    
    '** Update new data at current index  **'
     formMain_INA209.Pesgo2.YData(0, m_nRealTimeCounter) = Decmal209_Register(6)
     'Pesgo2.YData(1, m_nRealTimeCounter) = Decmal209_Register(9)
     formMain_INA209.Pesgo2.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
     'Pesgo2.XData(1, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA209.Pesgo2.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA209.Pesgo2.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA209.Pesgo2.VertLineAnnotationColor(0) = QBColor(12)

    '** Update image and force paint **'
     formMain_INA209.Pesgo2.PEnarg1 = 0
     formMain_INA209.Pesgo2.PEnarg2 = 0
     formMain_INA209.Pesgo2.PEactions = 0
 
 
 
 
     '** Update new data at current index  **'
     formMain_INA209.Pesgo3.YData(0, m_nRealTimeCounter) = Decmal209_Register(5)
     'Pesgo3.YData(1, m_nRealTimeCounter) = Decmal209_Register(9)
     formMain_INA209.Pesgo3.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
     'Pesgo3.XData(1, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA209.Pesgo3.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA209.Pesgo3.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA209.Pesgo3.VertLineAnnotationColor(0) = QBColor(12)

    '** Update image and force paint **'
     formMain_INA209.Pesgo3.PEnarg1 = 0
     formMain_INA209.Pesgo3.PEnarg2 = 0
     formMain_INA209.Pesgo3.PEactions = 0

 
 '** Increment counter **'
     m_nRealTimeCounter = Timer - real_time
 
 
 
        If m_nRealTimeCounter >= 100 Then
           m_nRealTimeCounter = 0
           real_time = Timer
        End If

End Sub

Public Sub Read_Ina209_ENG()
'Call random_reg
For REG = 0 To &H1B&
    Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(REG) + " ACKS P") 'set pointer
    Call RunMnemonicCommand("I2C CH1 S " + Hex(ReadAddress) + " ACKS R ACKM R ACKM P")
    Ina209Registers(REG) = ReadData(0) * &H100& + ReadData(1)
Next REG

For REG = 0 To &H1B&
    Call UpdateDecimal(REG)
Next REG

Call UpdateRegisterDisplay

End Sub
       

Public Function RegVal2Str(Inval As Long, Frmt As Integer, TwosComp As Boolean) As String
        ' inVal is the input number
        ' Frmt is the output format: 0 - binary, 1 - hex (4symbols), 2 - decimal
        ' TwosComp - 2's compliment flag, True/False
    Dim AdjVal As Long
    If TwosComp And (Inval < 0) Then    'processing 2's compliment value
        AdjVal = Inval + 65536
    Else
        AdjVal = Inval
    End If
    If (AdjVal < 0) Or (AdjVal > 65535) Then ' return empty str if input is out of limits
        RegVal2Str = ""
        Exit Function
    End If
    Select Case Frmt
    Case 0  ' binary
        RegVal2Str = Display16Bit(AdjVal)
    Case 1  ' hex
        RegVal2Str = Hex(AdjVal)    ' changed from Format(Hex(AdjVal), "0000")
        Do While Len(RegVal2Str) < 4
                ' add leading zeros
            RegVal2Str = "0" & RegVal2Str
        Loop
    Case 2 ' decimal (note: no 2's compliment in this case)
        RegVal2Str = Format(CStr(Inval), "#####0")
    End Select
End Function
Public Function binary2decmal(binaryVal As String) As Double
Dim dig_bin, dig_pow
binary2decmal = 0
dig_pow = 0
dig_bin = 0
For i = 0 To Len(binaryVal) - 1
    dig_bin = Mid(binaryVal, Len(binaryVal) - i, 1)
    If dig_bin = "1" Then
        binary2decmal = binary2decmal + 2 ^ (dig_pow)
    End If
    If dig_bin = "1" Or dig_bin = "0" Then
        dig_pow = dig_pow + 1
    End If
Next i
End Function

Public Function Display16Bit(Inval As Long) As String
    Display16Bit = DisplayBinary(Inval)
    If Len(Display16Bit) > 16 Then
        Display16Bit = Right(Display16Bit, 16)
    Else
        While Len(Display16Bit) < 16
'            If ((Len(Display16Bit) Mod 4) = 0) Then Display16Bit = "_" & Display16Bit
            Display16Bit = "0" & Display16Bit
        Wend
    End If
    Display16Bit = Mid(Display16Bit, 1, 4) & "_" _
                 & Mid(Display16Bit, 5, 4) & "_" _
                 & Mid(Display16Bit, 9, 4) & "_" _
                 & Mid(Display16Bit, 13, 4)
End Function
Public Function DisplayBinary(Inval As Long) As String
    If Inval = 0 Then
        DisplayBinary = 0
    Else
        DisplayBinary = DisplayBinary(Fix(Inval / 2#)) & Format(Inval Mod 2, "0")
    End If
End Function
Public Sub SetRegLegend()
  Dim i As Integer
  RegLegend(0) = "RST - Device Reset.  Resets all registers to devault values (Normal=0, Reset=1)" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "BRNG: Bus Voltage Range(0=16V, 1=32V)" & vbCrLf & _
    "PG1, PG0: Programable Gain (00=1, 01=div2, 10=div4, 11=div8)" & vbCrLf & _
    "B_ADC4,B_ADC3,B_ADC2,B_ADC2: Bus ADC Resolution/Averaging" & vbCrLf & _
    "S_ADC4,S_ADC3,S_ADC2,S_ADC1: Shunt ADC Resolution/Averaging" & vbCrLf & _
    "MODE3,MODE2,MODE1: Controls various modes of operation (e.g. trigered versus Continuous readings).  See data sheet for details."
 RegLegend(1) = "WOV: Warning Bus Overvoltage" & vbCrLf & _
    "WUV:   Warning Bus Undervoltage" & vbCrLf & _
    "WP:    Warning Power" & vbCrLf & _
    "WS+:   Warning Shunt +Voltage" & vbCrLf & _
    "WS-:   Warning Shunt -Voltage" & vbCrLf & _
    "OLOV:  Overlimit Bus Overvoltage" & vbCrLf & _
    "OLUV:  Overlimit Bus Undervoltage" & vbCrLf & _
    "OLP:   Overlimit Power" & vbCrLf & _
    "CNVR:  Conversion Ready." & vbCrLf & _
    "CRIT+: Critical Shunt +Voltage" & vbCrLf & _
    "CRIT-: Critical Shunt -Voltage" & vbCrLf & _
    "SMBA:  SMBus Alert (clears only on reading Status Reg or by disabling SMBus Alert function)." & vbCrLf & _
    "OVF:   Math overflow (indicates that current and power may be meaningless)" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'"
  RegLegend(2) = "M_WOV:  " & vbCrLf & _
    "M_WUV:  " & vbCrLf & _
    "MWP:  " & vbCrLf & _
    "MWS+:  " & vbCrLf & _
    "MWS-:  " & vbCrLf & _
    "M OLOV:  " & vbCrLf & _
    "M OLUV:  " & vbCrLf & _
    "M_OLP:  " & vbCrLf & _
    "M_CRIT+:  " & vbCrLf & _
    "M_CRIT-:  " & vbCrLf & _
    "M_CNVR:  " & vbCrLf & _
    "RFB:   " & vbCrLf & _
    "SMA_EN:  SMBus Alert Enable" & vbCrLf & _
    "CR_EN:  Critical Alarm Output Enable" & vbCrLf & _
    "OL_EN:  Overlimit Alarm Output Enable" & vbCrLf & _
    "WRN_EN:  Warning Alarm Output Enable" & vbCrLf
 RegLegend(3) = "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "EXS - Linearization Adjust & Excitation Voltage (VEXC) Gain Select (Range1 or Range2)" & vbCrLf & _
    "0=Range 1 (-0.166VFB < Linearization DAC Range < +0.166VFB, VEXC Gain=0.83VREF)" & vbCrLf & _
    "1=Range 2 (-0.124VFB < Linearization DAC Range < +0.124VFB, VEXC Gain=0.52VREF)" & vbCrLf & _
    "EXEN - VEXC Enable: 1= Enable VEXC; 0=Disable VEXC" & vbCrLf & _
    "RS - Internal VREF Select: 0=4.096V; 1=2.5V" & vbCrLf & _
    "REN - Enable/Disable Internal VREF (Disable for External VREF - Connect External VREF to REFIN/REFOUT pin):" & vbCrLf & _
    "   0=External Reference (Disable Internal Reference); 1=Internal Reference (Enable Internal Reference)" & vbCrLf & _
    "LD[7:0] - Linearization DAC setting, 7 bit + sign"
  RegLegend(4) = "BD15: " & vbCrLf & _
    "BD12: " & vbCrLf & _
    "BD11: " & vbCrLf & _
    "BD10: " & vbCrLf & _
    "BD9: " & vbCrLf & _
    "BD8: " & vbCrLf & _
    "BD7: " & vbCrLf & _
    "BD6: " & vbCrLf & _
    "BD5: " & vbCrLf & _
    "BD4: " & vbCrLf & _
    "BD3: " & vbCrLf & _
    "BD2: " & vbCrLf & _
    "BD1: " & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf
  RegLegend(5) = "PD15: " & vbCrLf & _
    "PD14: " & vbCrLf & _
    "PD13: " & vbCrLf & _
    "PD12: " & vbCrLf & _
    "PD11: " & vbCrLf & _
    "PD10: " & vbCrLf & _
    "PD9: " & vbCrLf & _
    "PD8: " & vbCrLf & _
    "PD7: " & vbCrLf & _
    "PD6: " & vbCrLf & _
    "PD5: " & vbCrLf & _
    "PD4: " & vbCrLf & _
    "PD3: " & vbCrLf & _
    "PD2: " & vbCrLf & _
    "PD1: " & vbCrLf & _
    "PD0: " & vbCrLf

  RegLegend(6) = "CSign: " & vbCrLf & _
    "CD14: " & vbCrLf & _
    "CD13: " & vbCrLf & _
    "CD12: " & vbCrLf & _
    "CD11: " & vbCrLf & _
    "CD10: " & vbCrLf & _
    "CD9: " & vbCrLf & _
    "CD8: " & vbCrLf & _
    "CD7: " & vbCrLf & _
    "CD6: " & vbCrLf & _
    "CD5: " & vbCrLf & _
    "CD4: " & vbCrLf & _
    "CD3: " & vbCrLf & _
    "CD2: " & vbCrLf & _
    "CD1: " & vbCrLf & _
    "CD0: " & vbCrLf

  RegLegend(7) = "SPP Sign: " & vbCrLf & _
    "SPP14: " & vbCrLf & _
    "SPP13: " & vbCrLf & _
    "SPP12: " & vbCrLf & _
    "SPP11: " & vbCrLf & _
    "SPP10: " & vbCrLf & _
    "SPP9: " & vbCrLf & _
    "SPP8: " & vbCrLf & _
    "SPP7: " & vbCrLf & _
    "SPP6: " & vbCrLf & _
    "SPP5: " & vbCrLf & _
    "SPP4: " & vbCrLf & _
    "SPP3: " & vbCrLf & _
    "SPP2: " & vbCrLf & _
    "SPP1: " & vbCrLf & _
    "SPP0: " & vbCrLf
    
  RegLegend(8) = "SPN Sign: " & vbCrLf & _
    "SPN14: " & vbCrLf & _
    "SPN13: " & vbCrLf & _
    "SPN12: " & vbCrLf & _
    "SPN11: " & vbCrLf & _
    "SPN10: " & vbCrLf & _
    "SPN9: " & vbCrLf & _
    "SPN8: " & vbCrLf & _
    "SPN7: " & vbCrLf & _
    "SPN6: " & vbCrLf & _
    "SPN5: " & vbCrLf & _
    "SPN4: " & vbCrLf & _
    "SPN3: " & vbCrLf & _
    "SPN2: " & vbCrLf & _
    "SPN1: " & vbCrLf & _
    "SPN0: "

  RegLegend(9) = "BH11: " & vbCrLf & _
    "BH10: " & vbCrLf & _
    "BH9: " & vbCrLf & _
    "BH8: " & vbCrLf & _
    "BH7: " & vbCrLf & _
    "BH6: " & vbCrLf & _
    "BH5: " & vbCrLf & _
    "BH4: " & vbCrLf & _
    "BH3: " & vbCrLf & _
    "BH2: " & vbCrLf & _
    "BH1: " & vbCrLf & _
    "BH0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "BPK: "

'reg 0x0A
  RegLegend(10) = "BL11: " & vbCrLf & _
    "BL10: " & vbCrLf & _
    "BL9: " & vbCrLf & _
    "BL8: " & vbCrLf & _
    "BL7: " & vbCrLf & _
    "BL6: " & vbCrLf & _
    "BL5: " & vbCrLf & _
    "BL4: " & vbCrLf & _
    "BL3: " & vbCrLf & _
    "BL2: " & vbCrLf & _
    "BL1: " & vbCrLf & _
    "BL0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "BL/RS: "
    
'reg 0x0B
RegLegend(11) = "PPK15: " & vbCrLf & _
    "PPK14: " & vbCrLf & _
    "PPK13: " & vbCrLf & _
    "PPK12: " & vbCrLf & _
    "PPK11: " & vbCrLf & _
    "PPK10: " & vbCrLf & _
    "PPK9: " & vbCrLf & _
    "PPK8: " & vbCrLf & _
    "PPK7: " & vbCrLf & _
    "PPK6: " & vbCrLf & _
    "PPK5: " & vbCrLf & _
    "PPK4: " & vbCrLf & _
    "PPK3: " & vbCrLf & _
    "PPK2: " & vbCrLf & _
    "PPK1: " & vbCrLf & _
    "PPK0/RS: " & vbCrLf

'reg 0x0C
 RegLegend(12) = "SWP Sign: " & vbCrLf & _
    "SWP14: " & vbCrLf & _
    "SWP13: " & vbCrLf & _
    "SWP12: " & vbCrLf & _
    "SWP11: " & vbCrLf & _
    "SWP10: " & vbCrLf & _
    "SWP9: " & vbCrLf & _
    "SWP8: " & vbCrLf & _
    "SWP7: " & vbCrLf & _
    "SWP6: " & vbCrLf & _
    "SWP5: " & vbCrLf & _
    "SWP4: " & vbCrLf & _
    "SWP3: " & vbCrLf & _
    "SWP2: " & vbCrLf & _
    "SWP1: " & vbCrLf & _
    "SWP0: " & vbCrLf

'reg 0x0D
 RegLegend(13) = "SWN Sign: " & vbCrLf & _
    "SWN14: " & vbCrLf & _
    "SWN13: " & vbCrLf & _
    "SWN12: " & vbCrLf & _
    "SWN11: " & vbCrLf & _
    "SWN10: " & vbCrLf & _
    "SWN9: " & vbCrLf & _
    "SWN8: " & vbCrLf & _
    "SWN7: " & vbCrLf & _
    "SWN6: " & vbCrLf & _
    "SWN5: " & vbCrLf & _
    "SWN4: " & vbCrLf & _
    "SWN3: " & vbCrLf & _
    "SWN2: " & vbCrLf & _
    "SWN1: " & vbCrLf & _
    "SWN0: " & vbCrLf

'reg 0x0E
RegLegend(14) = "PW15: " & vbCrLf & _
    "PW14: " & vbCrLf & _
    "PW13: " & vbCrLf & _
    "PW12: " & vbCrLf & _
    "PW11: " & vbCrLf & _
    "PW10: " & vbCrLf & _
    "PW9: " & vbCrLf & _
    "PW8: " & vbCrLf & _
    "PW7: " & vbCrLf & _
    "PW6: " & vbCrLf & _
    "PW5: " & vbCrLf & _
    "PW4: " & vbCrLf & _
    "PW3: " & vbCrLf & _
    "PW2: " & vbCrLf & _
    "PW1: " & vbCrLf & _
    "PW0: " & vbCrLf

 'reg 0x0F
RegLegend(15) = "BWO12: " & vbCrLf & _
    "BWO11: " & vbCrLf & _
    "BWO10: " & vbCrLf & _
    "BWO9: " & vbCrLf & _
    "BWO8: " & vbCrLf & _
    "BWO7: " & vbCrLf & _
    "BWO6: " & vbCrLf & _
    "BWO5: " & vbCrLf & _
    "BWO4: " & vbCrLf & _
    "BWO3: " & vbCrLf & _
    "BWO2: " & vbCrLf & _
    "BWO1: " & vbCrLf & _
    "BWO0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "WPL: " & vbCrLf & _
    "WNL: " & vbCrLf
    
 'reg 0x10
RegLegend(16) = "BWU12: " & vbCrLf & _
    "BWU11: " & vbCrLf & _
    "BWU10: " & vbCrLf & _
    "BWU9: " & vbCrLf & _
    "BWU8: " & vbCrLf & _
    "BWU7: " & vbCrLf & _
    "BWU6: " & vbCrLf & _
    "BWU5: " & vbCrLf & _
    "BWU4: " & vbCrLf & _
    "BWU3: " & vbCrLf & _
    "BWU2: " & vbCrLf & _
    "BWU1: " & vbCrLf & _
    "BWU0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x11
RegLegend(17) = "BWU12: " & vbCrLf & _
    "BWU11: " & vbCrLf & _
    "BWU10: " & vbCrLf & _
    "BWU9: " & vbCrLf & _
    "BWU8: " & vbCrLf & _
    "BWU7: " & vbCrLf & _
    "BWU6: " & vbCrLf & _
    "BWU5: " & vbCrLf & _
    "BWU4: " & vbCrLf & _
    "BWU3: " & vbCrLf & _
    "BWU2: " & vbCrLf & _
    "BWU1: " & vbCrLf & _
    "BWU0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x12
RegLegend(18) = "BWU12: " & vbCrLf & _
    "BWU11: " & vbCrLf & _
    "BWU10: " & vbCrLf & _
    "BWU9: " & vbCrLf & _
    "BWU8: " & vbCrLf & _
    "BWU7: " & vbCrLf & _
    "BWU6: " & vbCrLf & _
    "BWU5: " & vbCrLf & _
    "BWU4: " & vbCrLf & _
    "BWU3: " & vbCrLf & _
    "BWU2: " & vbCrLf & _
    "BWU1: " & vbCrLf & _
    "BWU0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x13
RegLegend(19) = "BWU12: " & vbCrLf & _
    "BWU11: " & vbCrLf & _
    "BWU10: " & vbCrLf & _
    "BWU9: " & vbCrLf & _
    "BWU8: " & vbCrLf & _
    "BWU7: " & vbCrLf & _
    "BWU6: " & vbCrLf & _
    "BWU5: " & vbCrLf & _
    "BWU4: " & vbCrLf & _
    "BWU3: " & vbCrLf & _
    "BWU2: " & vbCrLf & _
    "BWU1: " & vbCrLf & _
    "BWU0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x14
RegLegend(20) = "CDP7: " & vbCrLf & _
    "CDP6: " & vbCrLf & _
    "CDP5: " & vbCrLf & _
    "CDP4: " & vbCrLf & _
    "CDP3: " & vbCrLf & _
    "CDP2: " & vbCrLf & _
    "CDP1: " & vbCrLf & _
    "CDP0: " & vbCrLf & _
    "GP: " & vbCrLf & _
    "GPM1: " & vbCrLf & _
    "GPM0: " & vbCrLf & _
    "CP: " & vbCrLf & _
    "C_HYST2: " & vbCrLf & _
    "C_HYST1: " & vbCrLf & _
    "C_HYST0: " & vbCrLf & _
    "CRL:  " & vbCrLf

 'reg 0x15
RegLegend(21) = "CDP7: " & vbCrLf & _
    "CDP6: " & vbCrLf & _
    "CDP5: " & vbCrLf & _
    "CDP4: " & vbCrLf & _
    "CDP3: " & vbCrLf & _
    "CDP2: " & vbCrLf & _
    "CDP1: " & vbCrLf & _
    "CDP0: " & vbCrLf & _
    "CF3: " & vbCrLf & _
    "CF2: " & vbCrLf & _
    "CF1: " & vbCrLf & _
    "CF0: " & vbCrLf & _
    "WD2: " & vbCrLf & _
    "WD1:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "WD0:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf
 
 'reg 0x16
RegLegend(22) = "FS14: " & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x17
RegLegend(23) = "NOT USED" & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x18
RegLegend(24) = "FS14: " & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x19
RegLegend(25) = "FS14: " & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x1A
RegLegend(26) = "FS14: " & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

 'reg 0x1B
RegLegend(27) = "FS14: " & vbCrLf & _
    "FS13: " & vbCrLf & _
    "FS12: " & vbCrLf & _
    "FS11: " & vbCrLf & _
    "FS10: " & vbCrLf & _
    "FS9: " & vbCrLf & _
    "FS8: " & vbCrLf & _
    "FS7: " & vbCrLf & _
    "FS6: " & vbCrLf & _
    "FS5: " & vbCrLf & _
    "FS4: " & vbCrLf & _
    "FS3: " & vbCrLf & _
    "FS2: " & vbCrLf & _
    "FS1: " & vbCrLf & _
    "FS0: " & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0' " & vbCrLf

' now setting the individual bit tips
   ' RegBitTips(0) = Array("Reset", "D14", "BRNG", "PG1", "PG0", "B_ADC4", "B_ADC3", "B_ADC2", "B_ADC1", "S_ADC4", "S_ADC3", "S_ADC2", "S_ADC1", "MODE3", "MODE2", "MODE1")
   ' RegBitTips(1) = Array("Warning Over Voltage", "Warning Under Voltage", "Warning Power", "Warning+Shunt", "Warning-Shunt", "Overlimit Over Voltage", "Overlimit Under Voltage", "Overlimit Power", "Conversion Ready", "Crtical+Shunt", "Crtical-Shunt", "na", "na", "na", "na", "na")
   ' RegBitTips(2) = Array("Warning Over Voltage", "Warning Under Voltage", "Warning Power", "Warning+Shunt", "Warning-Shunt", "Overlimit Over Voltage", "Overlimit Under Voltage", "Overlimit Power", "Conversion Ready", "Crtical+Shunt", "Crtical-Shunt", "na", "na", "na", "na", "na")
   ' RegBitTips(3) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(4) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(5) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(6) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(7) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(8) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    'RegBitTips(9) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   '' RegBitTips(10) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(11) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(12) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(13) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(14) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    'RegBitTips(15) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(16) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(17) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(18) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(19) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   ' RegBitTips(20) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
   '' RegBitTips(21) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    'RegBitTips(22) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
' now setting the individual bit Labels
    RegBitLabel(0) = Array("Reset", "D14", "BRNG", "PG1", "PG0", "B_ADC4", "B_ADC3", "B_ADC2", "B_ADC1", "S_ADC4", "S_ADC3", "S_ADC2", "S_ADC1", "MODE3", "MODE2", "MODE1")
    RegBitLabel(1) = Array("WOV", "WUV", "WP", "WS+", "WS-", "OLOV", "OLUV", "OLP", "CRT+", "CRT-", "CNVR", "SMBA", "OVF", "RFB", "RFB", "RFB")
    RegBitLabel(2) = Array("M_WOV", "M_WUV", "MWP", "MWS+", "MWS-", "M_OLOV", "M_OLUV", "M_OLP", "M_CRIT+", "M_CRIT-", "M_CNVR", "RFB", "SMA_EN", "CR_EN", "OL_EN", "WRN_EN")
    RegBitLabel(3) = Array("Sign", "Sign", "Sign", "Sign", "SD11", "SD10", "SD9", "SD8", "SD7", "SD6", "SD5", "SD4", "SD3", "SD2", "SD1", "SD0")
    RegBitLabel(4) = Array("RFB", "BD11", "BD10", "BD9", "BD8", "BD7", "BD6", "BD5", "BD4", "BD3", "BD2", "BD1", "BD0", "RFB", "RFB", "RFB")
    RegBitLabel(5) = Array("PD15", "PD14", "PD13", "PD12", "PD11", "PD10", "PD9", "PD8", "PD7", "PD6", "PD5", "PD4", "PD3", "PD2", "PD1", "PD0")
    RegBitLabel(6) = Array("C_SIGN", "CD14", "CD13", "CD12", "CD11", "CD10", "CD9", "CD8", "CD7", "CD6", "CD5", "CD4", "CD3", "CD2", "CD1", "CD0")
    RegBitLabel(7) = Array("SPP_SIGN", "SPP14", "SPP13", "SPP12", "SPP11", "SPP10", "SPP9", "SPP8", "SPP7", "SPP6", "SPP5", "SPP4", "SPP3", "SPP2", "SPP1", "SPP0")
    RegBitLabel(8) = Array("SPN_SIGN", "SPN14", "SPN13", "SPN12", "SPN11", "SPN10", "SPN9", "SPN8", "SPN7", "SPN6", "SPN5", "SPN4", "SPN3", "SPN2", "SPN1", "SPN0")
    RegBitLabel(9) = Array("BH11", "BH10", "BH9", "BH8", "BH7", "BH6", "BH5", "BH4", "BH3", "BH2", "BH1", "BH0", "RFB", "RFB", "RFB", "BPK/RS")
    RegBitLabel(10) = Array("BL11", "BL10", "BL9", "BL8", "BL7", "BL6", "BL5", "BL4", "BL3", "BL2", "BL1", "BL0", "RFB", "RFB", "RFB", "BL/RS")
    RegBitLabel(11) = Array("PPK15", "PPK14", "PPK13", "PPK12", "PPK11", "PPK10", "PPK9", "PPK8", "PPK7", "PPK6", "PPK5", "PPK4", "PPK3", "PPK2", "PPK1", "PPK0/RS")
    RegBitLabel(12) = Array("SWP_SIGN", "SWP14", "SWP13", "SWP12", "SWP11", "SWP10", "SWP9", "SWP8", "SWP7", "SWP6", "SWP5", "SWP4", "SWP3", "SWP2", "SWP1", "SWP0")
    RegBitLabel(13) = Array("SWN_SIGN", "SWN14", "SWN13", "SWN12", "SWN11", "SWN10", "SWN9", "SWN8", "SWN7", "SWN6", "SWN5", "SWN4", "SWN3", "SWN2", "SWN1", "SWN0")
    RegBitLabel(14) = Array("PW15", "PW14", "PW13", "PW12", "PW11", "PW10", "PW9", "PW8", "PW7", "PW6", "PW5", "PW4", "PW3", "PW2", "PW1", "PW0")
    RegBitLabel(15) = Array("BWO12", "BWO11", "BWO10", "BWO9", "BWO8", "BWO7", "BWO6", "BWO5", "BWO4", "BWO3", "BWO2", "BWO1", "BWO0", "RFB", "WPL", "WNL")
    RegBitLabel(16) = Array("BWU12", "BWU11", "BWU10", "BWU9", "BWU8", "BWU7", "BWU6", "BWU5", "BWU4", "BWU3", "BWU2", "BWU1", "BWU0", "RFB", "RFB", "RFB")
    RegBitLabel(17) = Array("PO15", "PO14", "PO13", "PO12", "PO11", "PO10", "PO9", "PO8", "PO7", "PO6", "PO5", "PO4", "PO3", "PO2", "PO1", "PO0")
    RegBitLabel(18) = Array("BOO12", "BOO11", "BOO10", "BOO9", "BOO8", "BOO7", "BOO6", "BOO5", "BOO4", "BOO3", "BOO2", "BOO1", "BOO0", "RFB", "OLP", "OLL")
    RegBitLabel(19) = Array("BUO12", "BUO11", "BUO10", "BUO9", "BUO8", "BUO7", "BUO6", "BUO5", "BUO4", "BUO3", "BUO2", "BUO1", "BUO0", "RFB", "RFB", "RFB")
    RegBitLabel(20) = Array("CDP7", "CDP6", "CDP5", "CDP4", "CDP3", "CDP2", "CDP1", "CDP0", "GP", "GPM1", "GPM0", "CP", "C_HYST2", "C_HYST1", "C_HYST0", "CRL")
    RegBitLabel(21) = Array("CDP7", "CDP6", "CDP5", "CDP4", "CDP3", "CDP2", "CDP1", "CDP0", "CF3", "CF2", "CF1", "CF0", "WD3", "WD2", "WD1", "WD0")
    RegBitLabel(22) = Array("FS14", "FS13", "FS12", "FS11", "FS10", "FS9", "FS8", "FS7", "FS6", "FS5", "FS4", "FS3", "FS2", "FS1", "FS0", "RFB")
    RegBitLabel(23) = Array("-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-")
    RegBitLabel(24) = Array("FUS CTL", "FUS CTL", "FUS DIS", "-", "-", "-", "TEST", "TEST", "TEST", "FUS BI", "FUS BI", "TRM CT", "TRM CT", "0", "TRM PT", "TRM PT")
    RegBitLabel(25) = Array("15", "14", "13", "12", "11", "10", "9", "8", "7", "6", "5", "4", "3", "2", "1", "0")
    RegBitLabel(26) = Array("15", "14", "13", "12", "11", "10", "9", "8", "7", "6", "5", "4", "3", "2", "1", "0")
    RegBitLabel(27) = Array("15", "14", "13", "12", "11", "10", "9", "8", "7", "6", "5", "4", "3", "2", "1", "0")
    
    
 Reg_ReadOnly(0) = False
 Reg_ReadOnly(1) = True
 Reg_ReadOnly(2) = False
 Reg_ReadOnly(3) = True
 Reg_ReadOnly(4) = True
 Reg_ReadOnly(5) = True
 Reg_ReadOnly(6) = True
 Reg_ReadOnly(7) = False
 Reg_ReadOnly(8) = False
 Reg_ReadOnly(9) = False
 Reg_ReadOnly(10) = False
 Reg_ReadOnly(11) = False
 Reg_ReadOnly(12) = False
 Reg_ReadOnly(13) = False
 Reg_ReadOnly(14) = False
 Reg_ReadOnly(15) = False
 Reg_ReadOnly(16) = False
 Reg_ReadOnly(17) = False
 Reg_ReadOnly(18) = False
 Reg_ReadOnly(19) = False
 Reg_ReadOnly(20) = False
 Reg_ReadOnly(21) = False
 Reg_ReadOnly(22) = False
 Reg_ReadOnly(23) = True 'NOT USED
 Reg_ReadOnly(24) = False
 Reg_ReadOnly(25) = True
 Reg_ReadOnly(26) = True
 Reg_ReadOnly(27) = True
End Sub


Public Sub WriteAllRegisters()

    For i = 0 To &H16&
        If MarkRegForWrite(i) = True Then
            Call WriteReg(i)
        End If
    Next i
   For i = 0 To &H16&
            MarkRegForWrite(i) = False
    Next i


End Sub
Public Sub UpdateDisplay(RegNumber)

'
'  Update RegLegend acording to register settings
'
If RegNumber = 0 Then
    pg1_pg0 = ((&H1800) And (Ina209Registers(RegNumber))) / (2 ^ 11)
    If pg1_pg0 = 0 Then
        PGA_Gain = 1
        ShuntFSR = 0.04
    ElseIf pg1_pg0 = 1 Then
        PGA_Gain = 2
        ShuntFSR = 0.08
    ElseIf pg1_pg0 = 2 Then
        PGA_Gain = 4
        ShuntFSR = 0.16
    ElseIf pg1_pg0 = 3 Then
        PGA_Gain = 8
        ShuntFSR = 0.32
    End If
    '
    '  Update reg 3
    '
    RegLegend(3) = ""
    For i = 0 To 15
        If PGA_Gain = 1 And i < 15 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        ElseIf PGA_Gain = 2 And i < 14 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        ElseIf PGA_Gain = 4 And i < 13 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
       ElseIf PGA_Gain = 8 And i < 12 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        Else
            RegLegend(3) = "Sign bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "Sign bit"
       End If
            
    Next i
    '
    '  Update reg 4
    '
    BRNG = ((&H2000) And (Ina209Registers(RegNumber))) / (2 ^ 13)
    If BRNG = 0 Then
        Bus_Voltage_Range = 16
    ElseIf BRNG = 1 Then
        Bus_Voltage_Range = 32
    End If
    RegLegend(4) = ""
    For i = 0 To 15
       If Bus_Voltage_Range = 16 And i = 15 Then
            RegLegend(4) = "RFB:  Reserved Factory Bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "RFB"
       ElseIf i < 2 Then
            RegLegend(4) = "RFB:  Reserved Factory Bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "RFB"
       Else
            RegLegend(4) = "BD" + Str(i - 2) + ": Bus Voltage bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "BD" + Str(i - 2)
       End If
    Next i
    
End If

End Sub
Public Sub UpdateDecimal(RegNumber)
Select Case RegNumber
Case 3, 7, 8, &HC&, &HD&
    If (Ina209Registers(RegNumber) And (&H8000&)) = 0 Then
         Decmal209_Register(RegNumber) = Ina209Registers(RegNumber)
    Else
        Decmal209_Register(RegNumber) = -(&H8000& - (Ina209Registers(RegNumber) And &H7FFF&))
    End If
    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * 0.00001
Case 4, 9, &HA&, &HF&, &H10&, &H12&, &H13&
    Decmal209_Register(RegNumber) = Int(Ina209Registers(RegNumber) / (2 ^ 3)) 'shift right 3
    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * 0.004
Case 5, &HB&, &HE&, &H11&
    Decmal209_Register(RegNumber) = Ina209Registers(RegNumber) * PowerLSB
Case 6
    If (Ina209Registers(RegNumber) And (&H8000&)) = 0 Then
        Decmal209_Register(RegNumber) = Ina209Registers(RegNumber)
    Else
        Decmal209_Register(RegNumber) = -(&H8000& - (Ina209Registers(RegNumber) And &H7FFF&))
    End If
    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * CurrentLSB
Case &H14&   'critical dac+
    Decmal209_Register(RegNumber) = Int(Ina209Registers(RegNumber) / (2 ^ 8))
    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * 0.001
Case &H15&  'critical dac-
    Decmal209_Register(RegNumber) = Int(Ina209Registers(RegNumber) / (2 ^ 8))
    Decmal209_Register(RegNumber) = -Decmal209_Register(RegNumber) * 0.001
End Select

End Sub

Public Sub Integer_Register_to_Decimal(RegNumber, decmal_reg)
Select Case RegNumber
Case &HC&, &HD& 'SHUNT VOLTAGE
    signed_int = Int(decmal_reg / 0.00001)
    If Abs(signed_int) < &H7FFF& Then
        If signed_int >= 0 Then
            Ina209Registers(RegNumber) = signed_int
        Else
            Ina209Registers(RegNumber) = &H10000 - Abs(signed_int)
        End If
    Else
        MsgBox "Analog value out of range"
    End If
Case &HE&, &H11& 'Power Warning, Power OverLimit
    If PowerLSB <> 0 Then
    signed_int = Int(decmal_reg / PowerLSB)
    If Abs(signed_int) < &H7FFF Then
        Ina209Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range" + vbCrLf + "Max Power = " + Str(MaxPower)
    End If
    End If
Case &HF&, &H10&, &H12&, &H13& 'Bus voltage
    signed_int = Int(decmal_reg / 0.004)
    signed_int = signed_int * (2 ^ 3)
    If Abs(signed_int) < &HFFFF& Then
        Ina209Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range"
    End If
Case &H14&   'crit dac+
    signed_int = Int(decmal_reg / 0.001)
    signed_int = signed_int * (2 ^ 8)
    If Abs(signed_int) < &HFFFF& Then
        Ina209Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range"
    End If
Case &H15&  'crit dac-
    If decmal_reg <= 0 And decmal_reg >= -0.255 Then
    signed_int = Int(-decmal_reg / 0.001)
    signed_int = signed_int * (2 ^ 8)
    Ina209Registers(RegNumber) = signed_int
    Else
         MsgBox "Analog value out of range" + vbCrLf + "-0.255 < Critical Dac- <= 0"
    End If
End Select

End Sub

Public Sub Update_Controls()
Updating_Controls = True

    pg1_pg0 = ((&H1800) And (Ina209Registers(0))) / (2 ^ 11)
    If pg1_pg0 = 0 Then
        PGA_Gain = 1
        ShuntFSR = 0.04
    ElseIf pg1_pg0 = 1 Then
        PGA_Gain = 2
        ShuntFSR = 0.08
    ElseIf pg1_pg0 = 2 Then
        PGA_Gain = 4
        ShuntFSR = 0.16
    ElseIf pg1_pg0 = 3 Then
        PGA_Gain = 8
        ShuntFSR = 0.32
    End If
    formMain_INA209.txtMaxShunt = Euro_US_string_fix(ShuntFSR)
    formMain_INA209.cmbShuntGain.ListIndex = pg1_pg0
    
    formMain_INA209.cmbWarnPol.ListIndex = Shift_Right(Ina209Registers(&HF&) And &H2&, 1)  ' warning pol
    formMain_INA209.cmbOverlimPol.ListIndex = Shift_Right(Ina209Registers(&H12&) And &H2&, 1)  ' overlimit pol
    formMain_INA209.cmbCritFaultPol.ListIndex = Shift_Right(Ina209Registers(&H14&) And (2 ^ 4), 4) ' crit pol
    formMain_INA209.cmbCritCompHyst.ListIndex = Shift_Right(Ina209Registers(&H14&) And &HE&, 1) ' crit hyst
    
    BRNG = ((&H2000&) And (Ina209Registers(0))) / (2 ^ 13)
    If BRNG = 0 Then
        Bus_Voltage_Range = 16
    ElseIf BRNG = 1 Then
        Bus_Voltage_Range = 32
    End If
    formMain_INA209.cmbBusGain.ListIndex = BRNG
    formMain_INA209.txtMaxBus = Euro_US_string_fix(Bus_Voltage_Range)

    SADC = ((&H78&) And (Ina209Registers(0))) / (2 ^ 3)
    If SADC <= 7 Then
        formMain_INA209.cmbShuntResolution.ListIndex = (SADC) And (&H3&)
    ElseIf SADC > 7 Then
        formMain_INA209.cmbShuntResolution.ListIndex = SADC - 4
    End If
    

    BADC = ((&H780&) And (Ina209Registers(0))) / (2 ^ 7)
    If BADC <= 7 Then
        formMain_INA209.cmbBusResolution.ListIndex = (BADC) And (&H3&)
    ElseIf BADC > 7 Then
        formMain_INA209.cmbBusResolution.ListIndex = BADC - 4
    End If

    mode = ((&H7&) And (Ina209Registers(0)))
    formMain_INA209.cmbAdsMode.ListIndex = mode

    WD = ((&HF&) And (Ina209Registers(&H15&)))
    formMain_INA209.cmbProgDelay.ListIndex = WD
    
    For i = 5 To 15
           formMain_INA209.txtMask(i).Text = Right(Str(Shift_Right(Ina209Registers(2) And (2 ^ i), i)), 1)

    Next i
    
    formMain_INA209.chkWarningEnable.value = Shift_Right(Ina209Registers(2) And (2 ^ 0), 0)
    formMain_INA209.chkOverlimitEnable.value = Shift_Right(Ina209Registers(2) And (2 ^ 1), 1)
    formMain_INA209.chkEnableCriticalFault.value = Shift_Right(Ina209Registers(2) And (2 ^ 2), 2)
    formMain_INA209.chkSMB_AlertEnable.value = Shift_Right(Ina209Registers(2) And (2 ^ 3), 3)
    formMain_INA209.chkWarningLatch = Ina209Registers(&HF&) And &H1&
    formMain_INA209.chkOverlimitLatch = Ina209Registers(&H12&) And &H1&


Updating_Controls = False
End Sub
Public Sub Read_Controls()
If Updating_Controls = True Then Exit Sub

Call Integer_Register_to_Decimal(&H14&, EngineeringVal(formMain_INA209.txtCritical_Dac_p))
Call Integer_Register_to_Decimal(&H15&, EngineeringVal(formMain_INA209.txtCritical_Dac_m))
Call Integer_Register_to_Decimal(&H11&, EngineeringVal(formMain_INA209.txtPowerOverLimit))
Call Integer_Register_to_Decimal(&H12&, EngineeringVal(formMain_INA209.txt_Vbus_Over_Lim))
Call Integer_Register_to_Decimal(&H13&, EngineeringVal(formMain_INA209.txt_Vbus_Under_Lim))
Call Integer_Register_to_Decimal(&HE&, EngineeringVal(formMain_INA209.txtPowerWarning))

Call Integer_Register_to_Decimal(&HF&, EngineeringVal(formMain_INA209.txt_Vbus_Over_Voltage))
Call Integer_Register_to_Decimal(&H10&, EngineeringVal(formMain_INA209.txt_Vbus_Under_Voltage))
Call Integer_Register_to_Decimal(&HC&, EngineeringVal(formMain_INA209.txt_Shunt_V_Pos_Warn))
Call Integer_Register_to_Decimal(&HD&, EngineeringVal(formMain_INA209.txt_Shunt_V_Neg_Warn))

If formMain_INA209.cmbWarnPol.ListIndex = 0 Then ' warning pol
    Ina209Registers(&HF&) = Ina209Registers(&HF&) And &HFFFD& 'active low
Else
    Ina209Registers(&HF&) = Ina209Registers(&HF&) Or &H2& 'active high
End If

If formMain_INA209.chkWarningLatch = 0 Then
    Ina209Registers(&HF&) = Ina209Registers(&HF&) And &HFFFE& 'latch disabled
Else
    Ina209Registers(&HF&) = Ina209Registers(&HF&) Or &H1& 'latch inabled
End If

If formMain_INA209.chkOverlimitLatch = 0 Then
    Ina209Registers(&H12&) = Ina209Registers(&H12&) And &HFFFE& 'latch disabled
Else
    Ina209Registers(&H12&) = Ina209Registers(&H12&) Or &H1& 'latch inabled
End If

If formMain_INA209.cmbOverlimPol.ListIndex = 0 Then ' overlimit pol
    Ina209Registers(&H12&) = Ina209Registers(&H12&) And &HFFFD& 'active low
Else
    Ina209Registers(&H12&) = Ina209Registers(&H12&) Or &H2& 'active high
End If

If formMain_INA209.cmbCritFaultPol.ListIndex = 0 Then ' crit pol
    Ina209Registers(&H14&) = Ina209Registers(&H14&) And &HFFEF& 'active low
Else
    Ina209Registers(&H14&) = Ina209Registers(&H14&) Or &H10& 'active high
End If

If formMain_INA209.chkWarningEnable = 1 Then ' warning  en
    Ina209Registers(&H2&) = Ina209Registers(&H2&) Or &H1&
Else
    Ina209Registers(&H2&) = Ina209Registers(&H2&) And &HFFFE&
End If

If formMain_INA209.chkOverlimitEnable = 1 Then ' ovl  en
    Ina209Registers(&H2&) = Ina209Registers(&H2&) Or &H2&
Else
    Ina209Registers(&H2&) = Ina209Registers(&H2&) And &HFFFD&
End If


If formMain_INA209.chkSMB_AlertEnable = 1 Then ' smb  en
    Ina209Registers(&H2&) = Ina209Registers(&H2&) Or &H8&
Else
    Ina209Registers(&H2&) = Ina209Registers(&H2&) And &HFFF7&
End If



If formMain_INA209.chkCriticalLatch.value = 1 Then
    Ina209Registers(&H14&) = Ina209Registers(&H14&) Or &H1&
Else
    Ina209Registers(&H14&) = Ina209Registers(&H14&) And &HFFFE&
End If


If formMain_INA209.chkEnableCriticalFault.value = 1 Then
    Ina209Registers(&H2&) = Ina209Registers(&H2&) Or &H4&
Else
    Ina209Registers(&H2&) = Ina209Registers(&H2&) And &HFFFB&
End If


    '
    ' a1, a0
    '
    
    a0 = formMain_INA209.cmbA0.ListIndex
    a1 = formMain_INA209.cmbA1.ListIndex
    
    
    address = 4 * a1 + a0 + &H40&
    ReadAddress = address * 2 + 1
    WriteAddress = address * 2
    formMain_INA209.txtAddress = Hex$(address)
    '
    ' WD - Warning delay
    '

   WD = formMain_INA209.cmbProgDelay.ListIndex
   Ina209Registers(&H15&) = (Ina209Registers(&H15&) And &HFFF0&) Or (WD)
    '
    ' pg1_pg0 - PGA shunt voltage only
    '
    pg1_pg0 = (formMain_INA209.cmbShuntGain.ListIndex) * (2 ^ 11)
    Ina209Registers(0) = (Ina209Registers(0) And &HE7FF&) Or pg1_pg0
    '
    '
   SADC = formMain_INA209.cmbShuntResolution.ListIndex
   If SADC <= 3 Then
        SADC = (SADC) * (2 ^ 3)
   Else
        SADC = (SADC + 4) * (2 ^ 3)
   End If
   Ina209Registers(0) = (Ina209Registers(0) And &HFF87&) Or (SADC)
    '
    '
   BADC = formMain_INA209.cmbBusResolution.ListIndex
   If BADC <= 3 Then
        BADC = (BADC) * (2 ^ 7)
   Else
        BADC = (BADC + 4) * (2 ^ 7)
   End If
   Ina209Registers(0) = (Ina209Registers(0) And &HF87F&) Or (BADC)
    '
    '
        mode = formMain_INA209.cmbAdsMode.ListIndex
    Ina209Registers(0) = (Ina209Registers(0) And &HFFF8&) Or (mode)
    '
    ' BRNG - bus range
    '
   BRNG = (formMain_INA209.cmbBusGain.ListIndex) * (2 ^ 13)
   Ina209Registers(0) = (Ina209Registers(0) And &HDFFF&) Or (BRNG)



Ina209Registers(&H14&) = (Ina209Registers(&H14&) And &HFFF1&) Or (Shift_Left(formMain_INA209.cmbCritCompHyst.ListIndex, 1)) ' crit hyst

Call UpdateRegisterDisplay

End Sub

Public Sub random_reg()
For i = 0 To &H16
Ina209Registers(i) = Int(Rnd(1) * &HFFFF&)
'MsgBox Hex$(Ina209Registers(RegNumber))
Next i
End Sub
Public Sub WriteReg(RegNumber)
REG_MSB = Int(Ina209Registers(RegNumber) / &H100&)
REG_LSB = Ina209Registers(RegNumber) And &HFF&
Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(RegNumber) + " ACKS " + Hex(REG_MSB) + " ACKS " + Hex(REG_LSB) + " ACKS " + " P") 'set pointer

Call UpdateDisplay(RegNumber)
End Sub


